/* cg_lvalue.c.  Generated automatically by treecc */
#line 3 "cg_lvalue.tc"

/*
 * cg_lvalue.tc - Identifier and l-value nodes.
 *
 * Copyright (C) 2001  Southern Storm Software, Pty Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <codegen/cg_nodes.h>

#line 330 "cg_lvalue.tc"


/*
 * Resolve and call a specific method for a multi-dimensional array.
 */
static void CallMArrayMethod(ILGenInfo *info, ILType *arrayType,
							 const char *name)
{
	ILClass *classInfo;
	ILMethod *method;

	/* Get the class information block for the array */
	classInfo = ILTypeToClass(info, arrayType);
	if(!classInfo)
	{
		return;
	}

	/* Find the method called "name" */
	if((method = (ILMethod *)ILClassNextMemberMatch
		(classInfo, (ILMember *)0, IL_META_MEMBERKIND_METHOD, name, 0)) != 0)
	{
		ILGenCallByMethod(info, method);
	}
}

#line 54 "cg_lvalue.c"

ILMachineType ILNode_Identifier_ILNode_GetType__(ILNode_Identifier *node, ILGenInfo * info)
#line 36 "cg_lvalue.tc"
{
	return ILMachineType_Void;
}
#line 61 "cg_lvalue.c"

void ILNode_Identifier_ILNode_GenDiscard__(ILNode_Identifier *node, ILGenInfo * info)
#line 45 "cg_lvalue.tc"
{
}
#line 67 "cg_lvalue.c"

ILMachineType ILNode_Identifier_ILNode_GenValue__(ILNode_Identifier *node, ILGenInfo * info)
#line 36 "cg_lvalue.tc"
{
	return ILMachineType_Void;
}
#line 74 "cg_lvalue.c"

void ILNode_Identifier_ILNode_GenThen__(ILNode_Identifier *node, ILGenInfo * info, ILLabel * label)
#line 45 "cg_lvalue.tc"
{
}
#line 80 "cg_lvalue.c"

void ILNode_Identifier_ILNode_GenElse__(ILNode_Identifier *node, ILGenInfo * info, ILLabel * label)
#line 45 "cg_lvalue.tc"
{
}
#line 86 "cg_lvalue.c"

int ILNode_Identifier_ILNode_EvalConst__(ILNode_Identifier *node, ILGenInfo * info, ILEvalValue * value)
#line 49 "cg_lvalue.tc"
{
	return 0;
}
#line 93 "cg_lvalue.c"

struct ILNode_Identifier_vtable__ const ILNode_Identifier_vt__ = {
	&ILNode_vt__,
	ILNode_Identifier_kind,
	"ILNode_Identifier",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Identifier_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Identifier_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Identifier_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Identifier_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Identifier_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Identifier_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_QualIdent_ILNode_GetType__(ILNode_QualIdent *node, ILGenInfo * info)
#line 36 "cg_lvalue.tc"
{
	return ILMachineType_Void;
}
#line 113 "cg_lvalue.c"

void ILNode_QualIdent_ILNode_GenDiscard__(ILNode_QualIdent *node, ILGenInfo * info)
#line 45 "cg_lvalue.tc"
{
}
#line 119 "cg_lvalue.c"

ILMachineType ILNode_QualIdent_ILNode_GenValue__(ILNode_QualIdent *node, ILGenInfo * info)
#line 36 "cg_lvalue.tc"
{
	return ILMachineType_Void;
}
#line 126 "cg_lvalue.c"

void ILNode_QualIdent_ILNode_GenThen__(ILNode_QualIdent *node, ILGenInfo * info, ILLabel * label)
#line 45 "cg_lvalue.tc"
{
}
#line 132 "cg_lvalue.c"

void ILNode_QualIdent_ILNode_GenElse__(ILNode_QualIdent *node, ILGenInfo * info, ILLabel * label)
#line 45 "cg_lvalue.tc"
{
}
#line 138 "cg_lvalue.c"

int ILNode_QualIdent_ILNode_EvalConst__(ILNode_QualIdent *node, ILGenInfo * info, ILEvalValue * value)
#line 49 "cg_lvalue.tc"
{
	return 0;
}
#line 145 "cg_lvalue.c"

struct ILNode_QualIdent_vtable__ const ILNode_QualIdent_vt__ = {
	&ILNode_vt__,
	ILNode_QualIdent_kind,
	"ILNode_QualIdent",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_QualIdent_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_QualIdent_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_QualIdent_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_QualIdent_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_QualIdent_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_QualIdent_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_LocalVar_ILNode_GetType__(ILNode_LocalVar *node, ILGenInfo * info)
#line 58 "cg_lvalue.tc"
{
	return node->machineType;
}
#line 165 "cg_lvalue.c"

void ILNode_LocalVar_ILNode_GenDiscard__(ILNode_LocalVar *node, ILGenInfo * info)
#line 122 "cg_lvalue.tc"
{
	/* Nothing needs to be done here */
}
#line 172 "cg_lvalue.c"

ILMachineType ILNode_LocalVar_ILNode_GenValue__(ILNode_LocalVar *node, ILGenInfo * info)
#line 183 "cg_lvalue.tc"
{
	ILGenLoadLocal(info, node->index);
	ILGenAdjust(info, 1);
	return node->machineType;
}
#line 181 "cg_lvalue.c"

ILMachineType ILNode_LocalVar_ILNode_Prepare__(ILNode_LocalVar *node, ILGenInfo * info, void * * data1, void * * data2)
#line 410 "cg_lvalue.tc"
{
	/* No preparation is needed for locals or arguments */
	return node->machineType;
}
#line 189 "cg_lvalue.c"

ILMachineType ILNode_LocalVar_ILNode_GetAndPrepare__(ILNode_LocalVar *node, ILGenInfo * info, int leave, void * * data1, void * * data2)
#line 546 "cg_lvalue.tc"
{
	ILGenLoadLocal(info, node->index);
	ILGenAdjust(info, 1);
	if(leave)
	{
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
	}
	return node->machineType;
}
#line 203 "cg_lvalue.c"

void ILNode_LocalVar_ILNode_Store__(ILNode_LocalVar *node, ILGenInfo * info, int leave, void * data1, void * data2)
#line 1119 "cg_lvalue.tc"
{
	if(leave)
	{
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
	}
	ILGenStoreLocal(info, node->index);
	ILGenAdjust(info, -1);
}
#line 216 "cg_lvalue.c"

void ILNode_LocalVar_ILNode_GenRef__(ILNode_LocalVar *node, ILGenInfo * info)
#line 1429 "cg_lvalue.tc"
{
	ILGenLoadLocalAddr(info, node->index);
	ILGenAdjust(info, 1);
}
#line 224 "cg_lvalue.c"

struct ILNode_LocalVar_vtable__ const ILNode_LocalVar_vt__ = {
	&ILNode_LValue_vt__,
	ILNode_LocalVar_kind,
	"ILNode_LocalVar",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_LocalVar_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_LocalVar_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_LocalVar_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Expression_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, void * * data1, void * * data2))ILNode_LocalVar_ILNode_Prepare__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * * data1, void * * data2))ILNode_LocalVar_ILNode_GetAndPrepare__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * data1, void * data2))ILNode_LocalVar_ILNode_Store__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info))ILNode_LocalVar_ILNode_GenRef__,
};

ILMachineType ILNode_ArgumentVar_ILNode_GetType__(ILNode_ArgumentVar *node, ILGenInfo * info)
#line 58 "cg_lvalue.tc"
{
	return node->machineType;
}
#line 248 "cg_lvalue.c"

void ILNode_ArgumentVar_ILNode_GenDiscard__(ILNode_ArgumentVar *node, ILGenInfo * info)
#line 122 "cg_lvalue.tc"
{
	/* Nothing needs to be done here */
}
#line 255 "cg_lvalue.c"

ILMachineType ILNode_ArgumentVar_ILNode_GenValue__(ILNode_ArgumentVar *node, ILGenInfo * info)
#line 193 "cg_lvalue.tc"
{
	ILGenLoadArg(info, node->index);
	ILGenAdjust(info, 1);
	return node->machineType;
}
#line 264 "cg_lvalue.c"

ILMachineType ILNode_ArgumentVar_ILNode_Prepare__(ILNode_ArgumentVar *node, ILGenInfo * info, void * * data1, void * * data2)
#line 410 "cg_lvalue.tc"
{
	/* No preparation is needed for locals or arguments */
	return node->machineType;
}
#line 272 "cg_lvalue.c"

ILMachineType ILNode_ArgumentVar_ILNode_GetAndPrepare__(ILNode_ArgumentVar *node, ILGenInfo * info, int leave, void * * data1, void * * data2)
#line 561 "cg_lvalue.tc"
{
	ILGenLoadArg(info, node->index);
	ILGenAdjust(info, 1);
	if(leave)
	{
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
	}
	return node->machineType;
}
#line 286 "cg_lvalue.c"

void ILNode_ArgumentVar_ILNode_Store__(ILNode_ArgumentVar *node, ILGenInfo * info, int leave, void * data1, void * data2)
#line 1133 "cg_lvalue.tc"
{
	if(leave)
	{
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
	}
	ILGenStoreArg(info, node->index);
	ILGenAdjust(info, -1);
}
#line 299 "cg_lvalue.c"

void ILNode_ArgumentVar_ILNode_GenRef__(ILNode_ArgumentVar *node, ILGenInfo * info)
#line 1438 "cg_lvalue.tc"
{
	ILGenLoadArgAddr(info, node->index);
	ILGenAdjust(info, 1);
}
#line 307 "cg_lvalue.c"

struct ILNode_ArgumentVar_vtable__ const ILNode_ArgumentVar_vt__ = {
	&ILNode_LValue_vt__,
	ILNode_ArgumentVar_kind,
	"ILNode_ArgumentVar",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_ArgumentVar_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_ArgumentVar_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_ArgumentVar_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Expression_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, void * * data1, void * * data2))ILNode_ArgumentVar_ILNode_Prepare__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * * data1, void * * data2))ILNode_ArgumentVar_ILNode_GetAndPrepare__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * data1, void * data2))ILNode_ArgumentVar_ILNode_Store__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info))ILNode_ArgumentVar_ILNode_GenRef__,
};

ILMachineType ILNode_RefArgumentVar_ILNode_GetType__(ILNode_RefArgumentVar *node, ILGenInfo * info)
#line 66 "cg_lvalue.tc"
{
	return node->machineType;
}
#line 331 "cg_lvalue.c"

void ILNode_RefArgumentVar_ILNode_GenDiscard__(ILNode_RefArgumentVar *node, ILGenInfo * info)
#line 122 "cg_lvalue.tc"
{
	/* Nothing needs to be done here */
}
#line 338 "cg_lvalue.c"

ILMachineType ILNode_RefArgumentVar_ILNode_GenValue__(ILNode_RefArgumentVar *node, ILGenInfo * info)
#line 203 "cg_lvalue.tc"
{
	/* Load the reference onto the stack */
	ILGenLoadArg(info, node->index);
	ILGenAdjust(info, 1);

	/* Dereference the pointer to get the actual value */
	ILGenLoadManaged(info, node->machineType, node->type);

	/* Return the value's type to the caller */
	return node->machineType;
}
#line 353 "cg_lvalue.c"

ILMachineType ILNode_RefArgumentVar_ILNode_Prepare__(ILNode_RefArgumentVar *node, ILGenInfo * info, void * * data1, void * * data2)
#line 419 "cg_lvalue.tc"
{
	/* Load the managed pointer onto the stack */
	ILGenLoadArg(info, node->index);
	ILGenAdjust(info, 1);
	return node->machineType;
}
#line 363 "cg_lvalue.c"

ILMachineType ILNode_RefArgumentVar_ILNode_GetAndPrepare__(ILNode_RefArgumentVar *node, ILGenInfo * info, int leave, void * * data1, void * * data2)
#line 576 "cg_lvalue.tc"
{
	/* Do we need to leave an extra copy of the value on the stack? */
	if(leave)
	{
		/* Load the managed pointer onto the stack */
		ILGenLoadArg(info, node->index);
		ILGenAdjust(info, 1);

		/* Get the current value of the variable for the left copy */
		ILGenLoadManaged(info, node->machineType, node->type);
	}

	/* Load the managed pointer onto the stack */
	ILGenLoadArg(info, node->index);
	ILGenAdjust(info, 1);

	/* Duplicate the pointer for a later store */
	ILGenSimple(info, IL_OP_DUP);
	ILGenAdjust(info, 1);

	/* Get the current value of the variable */
	ILGenLoadManaged(info, node->machineType, node->type);

	/* Return the value's type to the caller */
	return node->machineType;
}
#line 393 "cg_lvalue.c"

void ILNode_RefArgumentVar_ILNode_Store__(ILNode_RefArgumentVar *node, ILGenInfo * info, int leave, void * data1, void * data2)
#line 1147 "cg_lvalue.tc"
{
	if(leave)
	{
		/* Allocate a temporary local to hold the "left" copy */
		unsigned tempVar = ILGenTempTypedVar(info, node->type);

		/* Duplicate the top-most value and store into the temporary local */
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
		ILGenStoreLocal(info, tempVar);
		ILGenAdjust(info, -1);

		/* Store the value into the managed pointer */
		ILGenStoreManaged(info, node->machineType, node->type);
		ILGenAdjust(info, -2);

		/* Re-push the temporary local */
		ILGenLoadLocal(info, tempVar);
		ILGenAdjust(info, 1);

		/* Release the temporary local, which we no longer require */
		ILGenReleaseTempVar(info, tempVar);
	}
	else
	{
		/* Store the value into the managed pointer */
		ILGenStoreManaged(info, node->machineType, node->type);
		ILGenAdjust(info, -2);
	}
}
#line 427 "cg_lvalue.c"

void ILNode_RefArgumentVar_ILNode_GenRef__(ILNode_RefArgumentVar *node, ILGenInfo * info)
#line 1447 "cg_lvalue.tc"
{
	ILGenLoadArg(info, node->index);
	ILGenAdjust(info, 1);
}
#line 435 "cg_lvalue.c"

struct ILNode_RefArgumentVar_vtable__ const ILNode_RefArgumentVar_vt__ = {
	&ILNode_LValue_vt__,
	ILNode_RefArgumentVar_kind,
	"ILNode_RefArgumentVar",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_RefArgumentVar_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_RefArgumentVar_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_RefArgumentVar_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Expression_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, void * * data1, void * * data2))ILNode_RefArgumentVar_ILNode_Prepare__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * * data1, void * * data2))ILNode_RefArgumentVar_ILNode_GetAndPrepare__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * data1, void * data2))ILNode_RefArgumentVar_ILNode_Store__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info))ILNode_RefArgumentVar_ILNode_GenRef__,
};

ILMachineType ILNode_StaticField_ILNode_GetType__(ILNode_StaticField *node, ILGenInfo * info)
#line 86 "cg_lvalue.tc"
{
	return ILTypeToMachineType(ILField_Type(node->field));
}
#line 459 "cg_lvalue.c"

void ILNode_StaticField_ILNode_GenDiscard__(ILNode_StaticField *node, ILGenInfo * info)
#line 157 "cg_lvalue.tc"
{
	/* Nothing to do here */
}
#line 466 "cg_lvalue.c"

ILMachineType ILNode_StaticField_ILNode_GenValue__(ILNode_StaticField *node, ILGenInfo * info)
#line 279 "cg_lvalue.tc"
{
	ILGenFieldRef(info, IL_OP_LDSFLD, node->field);
	ILGenAdjust(info, 1);
	return ILTypeToMachineType(ILField_Type(node->field));
}
#line 475 "cg_lvalue.c"

ILMachineType ILNode_StaticField_ILNode_Prepare__(ILNode_StaticField *node, ILGenInfo * info, void * * data1, void * * data2)
#line 467 "cg_lvalue.tc"
{
	/* Nothing needs to be done here */
	return ILTypeToMachineType(ILField_Type(node->field));
}
#line 483 "cg_lvalue.c"

ILMachineType ILNode_StaticField_ILNode_GetAndPrepare__(ILNode_StaticField *node, ILGenInfo * info, int leave, void * * data1, void * * data2)
#line 668 "cg_lvalue.tc"
{
	ILGenFieldRef(info, IL_OP_LDSFLD, node->field);
	ILGenAdjust(info, 1);
	if(leave)
	{
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
	}
	return ILTypeToMachineType(ILField_Type(node->field));
}
#line 497 "cg_lvalue.c"

void ILNode_StaticField_ILNode_Store__(ILNode_StaticField *node, ILGenInfo * info, int leave, void * data1, void * data2)
#line 1206 "cg_lvalue.tc"
{
	if(leave)
	{
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
	}
	ILGenFieldRef(info, IL_OP_STSFLD, node->field);
	ILGenAdjust(info, -1);
}
#line 510 "cg_lvalue.c"

void ILNode_StaticField_ILNode_GenRef__(ILNode_StaticField *node, ILGenInfo * info)
#line 1456 "cg_lvalue.tc"
{
	ILGenFieldRef(info, IL_OP_LDSFLDA, node->field);
	ILGenAdjust(info, 1);
}
#line 518 "cg_lvalue.c"

struct ILNode_StaticField_vtable__ const ILNode_StaticField_vt__ = {
	&ILNode_LValue_vt__,
	ILNode_StaticField_kind,
	"ILNode_StaticField",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_StaticField_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_StaticField_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_StaticField_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Expression_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, void * * data1, void * * data2))ILNode_StaticField_ILNode_Prepare__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * * data1, void * * data2))ILNode_StaticField_ILNode_GetAndPrepare__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * data1, void * data2))ILNode_StaticField_ILNode_Store__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info))ILNode_StaticField_ILNode_GenRef__,
};

ILMachineType ILNode_MemberField_ILNode_GetType__(ILNode_MemberField *node, ILGenInfo * info)
#line 86 "cg_lvalue.tc"
{
	return ILTypeToMachineType(ILField_Type(node->field));
}
#line 542 "cg_lvalue.c"

ILMachineType ILNode_MemberField_ILNode_GenValue__(ILNode_MemberField *node, ILGenInfo * info)
#line 289 "cg_lvalue.tc"
{
	unsigned tempVar = ILGenPrepareForThisAccess
		(info, node->expr, ILField_Owner(node->field), 1);
	ILGenFieldRef(info, IL_OP_LDFLD, node->field);
	ILGenFreeThisVar(info, tempVar);
	return ILTypeToMachineType(ILField_Type(node->field));
}
#line 553 "cg_lvalue.c"

ILMachineType ILNode_MemberField_ILNode_Prepare__(ILNode_MemberField *node, ILGenInfo * info, void * * data1, void * * data2)
#line 476 "cg_lvalue.tc"
{
	ILGenPrepareForThisAccess(info, node->expr, ILField_Owner(node->field), 0);
	node->tempVar = IL_MAX_UINT32;
	return ILTypeToMachineType(ILField_Type(node->field));
}
#line 562 "cg_lvalue.c"

ILMachineType ILNode_MemberField_ILNode_GetAndPrepare__(ILNode_MemberField *node, ILGenInfo * info, int leave, void * * data1, void * * data2)
#line 683 "cg_lvalue.tc"
{
	/* Generate the object reference */
	ILGenPrepareForThisAccess(info, node->expr, ILField_Owner(node->field), 0);

	/* Do we need to leave the current value on the stack for later? */
	if(leave)
	{
		/* Duplicate the object reference and get the current value */
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
		ILGenFieldRef(info, IL_OP_LDFLD, node->field);

		/* Store the current value into a temporary local */
		node->tempVar = ILGenTempTypedVar(info, ILField_Type(node->field));
		ILGenSimple(info, IL_OP_DUP);
		ILGenStoreLocal(info, node->tempVar);
		ILGenExtend(info, 1);
	}
	else
	{
		/* Duplicate the object reference for the later store */
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);

		/* Load the current value from the field */
		ILGenFieldRef(info, IL_OP_LDFLD, node->field);

		/* We don't need to reload a previous value in "Store" */
		node->tempVar = IL_MAX_UINT32;
	}
	return ILTypeToMachineType(ILField_Type(node->field));
}
#line 598 "cg_lvalue.c"

void ILNode_MemberField_ILNode_Store__(ILNode_MemberField *node, ILGenInfo * info, int leave, void * data1, void * data2)
#line 1221 "cg_lvalue.tc"
{
	if(leave)
	{
		/* Copy the result into a temporary local */
		unsigned temp = ILGenTempTypedVar(info, ILField_Type(node->field));
		ILGenSimple(info, IL_OP_DUP);
		ILGenStoreLocal(info, temp);
		ILGenExtend(info, 1);

		/* Store the value into the field */
		ILGenFieldRef(info, IL_OP_STFLD, node->field);
		ILGenAdjust(info, -2);

		/* Do we need to restore a previous value to the stack top? */
		if(node->tempVar != IL_MAX_UINT32)
		{
			ILGenLoadLocal(info, node->tempVar);
			ILGenAdjust(info, 1);
			ILGenReleaseTempVar(info, node->tempVar);
		}

		/* Reload the contents of the temporary local */
		ILGenLoadLocal(info, temp);
		ILGenAdjust(info, 1);
		ILGenReleaseTempVar(info, temp);
	}
	else
	{
		/* Store the value into the field */
		ILGenFieldRef(info, IL_OP_STFLD, node->field);
		ILGenAdjust(info, -2);

		/* Do we need to restore a previous value to the stack top? */
		if(node->tempVar != IL_MAX_UINT32)
		{
			ILGenLoadLocal(info, node->tempVar);
			ILGenAdjust(info, 1);
			ILGenReleaseTempVar(info, node->tempVar);
		}
	}
}
#line 643 "cg_lvalue.c"

void ILNode_MemberField_ILNode_GenRef__(ILNode_MemberField *node, ILGenInfo * info)
#line 1465 "cg_lvalue.tc"
{
	unsigned tempVar = ILGenPrepareForThisAccess
		(info, node->expr, ILField_Owner(node->field), 1);
	ILGenFieldRef(info, IL_OP_LDFLDA, node->field);
	ILGenFreeThisVar(info, tempVar);
}
#line 653 "cg_lvalue.c"

struct ILNode_MemberField_vtable__ const ILNode_MemberField_vt__ = {
	&ILNode_LValue_vt__,
	ILNode_MemberField_kind,
	"ILNode_MemberField",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_MemberField_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Expression_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_MemberField_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Expression_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, void * * data1, void * * data2))ILNode_MemberField_ILNode_Prepare__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * * data1, void * * data2))ILNode_MemberField_ILNode_GetAndPrepare__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * data1, void * data2))ILNode_MemberField_ILNode_Store__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info))ILNode_MemberField_ILNode_GenRef__,
};

ILMachineType ILNode_ArrayAccess_ILNode_GetType__(ILNode_ArrayAccess *node, ILGenInfo * info)
#line 104 "cg_lvalue.tc"
{
	return ILTypeToMachineType(node->elemType);
}
#line 677 "cg_lvalue.c"

void ILNode_ArrayAccess_ILNode_GenDiscard__(ILNode_ArrayAccess *node, ILGenInfo * info)
#line 165 "cg_lvalue.tc"
{
	ILNode_GenDiscard(node->array, info);
	ILNode_GenDiscard(node->indices, info);
}
#line 685 "cg_lvalue.c"

ILMachineType ILNode_ArrayAccess_ILNode_GenValue__(ILNode_ArrayAccess *node, ILGenInfo * info)
#line 362 "cg_lvalue.tc"
{
	ILMachineType machineType = ILTypeToMachineType(node->elemType);
	long saveStack;
	if(ILType_IsSimpleArray(node->arrayType))
	{
		/* We can use a simple "ldelem" instruction */
		ILNode_GenValue(node->array, info);
		ILNode_GenValue(node->indices, info);
		ILGenLoadArray(info, machineType, node->elemType);
		ILGenAdjust(info, -1);
	}
	else
	{
		/* We have to call a method to get the value */
		saveStack = info->stackHeight;
		ILNode_GenValue(node->array, info);
		ILNode_GenValue(node->indices, info);
		CallMArrayMethod(info, node->arrayType, "Get");
		info->stackHeight = saveStack + 1;
	}
	return machineType;
}
#line 711 "cg_lvalue.c"

ILMachineType ILNode_ArrayAccess_ILNode_Prepare__(ILNode_ArrayAccess *node, ILGenInfo * info, void * * data1, void * * data2)
#line 507 "cg_lvalue.tc"
{
	ILMachineType machineType = ILTypeToMachineType(node->elemType);

	/* Save the current stack position, so "Store" knows what to pop */
	node->saveStack = info->stackHeight;

	/* Push the object and indices onto the stack */
	ILNode_GenValue(node->array, info);
	ILNode_GenValue(node->indices, info);

	/* If this is a simple array of managed values, then we need to
	   compute the address of the element for use in the store */
	if(ILType_IsSimpleArray(node->arrayType) &&
	   (machineType == ILMachineType_Decimal ||
	    machineType == ILMachineType_ManagedValue))
	{
		ILGenTypeToken(info, IL_OP_LDELEMA, node->elemType);
		ILGenAdjust(info, -1);
	}

	/* Return the element's machine type to the caller */
	return machineType;
}
#line 738 "cg_lvalue.c"

ILMachineType ILNode_ArrayAccess_ILNode_GetAndPrepare__(ILNode_ArrayAccess *node, ILGenInfo * info, int leave, void * * data1, void * * data2)
#line 795 "cg_lvalue.tc"
{
	ILMachineType machineType = ILTypeToMachineType(node->elemType);
	unsigned tempArrayVar;
	unsigned tempIndexVar;
	unsigned tempValueVar;
	unsigned *tempIndexVars;
	int rank, dim, posn;
	ILNode *indexNode;
	int isManagedValue;

	/* Save the current stack position so "Store" knows what to pop */
	node->saveStack = info->stackHeight;

	/* Determine if the element type is a managed value */
	isManagedValue = (machineType == ILMachineType_Decimal ||
					  machineType == ILMachineType_ManagedValue);

	/* Determine what kind of array we are dealing with */
	if(ILType_IsSimpleArray(node->arrayType))
	{
		/* We need some temporary variables to assist with
		   the duplication of the values */
		tempArrayVar = ILGenTempTypedVar(info, node->arrayType);
		tempIndexVar = ILGenTempTypedVar(info, ILType_Int32);

		/* Get the array reference and save it */
		ILNode_GenValue(node->array, info);
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
		ILGenStoreLocal(info, tempArrayVar);
		ILGenAdjust(info, -1);

		/* Get the index value and save it */
		ILNode_GenValue(node->indices, info);
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
		ILGenStoreLocal(info, tempIndexVar);
		ILGenAdjust(info, -1);

		/* Do we need to leave the current value on the stack? */
		if(leave)
		{
			/* Get the array element and save it */
			tempValueVar = ILGenTempTypedVar(info, node->elemType);
			ILGenLoadArray(info, machineType, node->elemType);
			ILGenSimple(info, IL_OP_DUP);
			ILGenStoreLocal(info, tempValueVar);
			ILGenAdjust(info, -1);

			/* Reload all saved values back onto the stack */
			ILGenLoadLocal(info, tempArrayVar);
			ILGenLoadLocal(info, tempIndexVar);
			ILGenAdjust(info, 2);
			if(isManagedValue)
			{
				/* When we do the store, we need an address on the stack */
				ILGenTypeToken(info, IL_OP_LDELEMA, node->elemType);
				ILGenAdjust(info, -1);
			}
			ILGenLoadLocal(info, tempValueVar);
			ILGenAdjust(info, 1);

			/* Account for the extra value that we will be leaving behind */
			++(node->saveStack);

			/* Release the extra temporary variable that we used */
			ILGenReleaseTempVar(info, tempValueVar);
		}
		else
		{
			/* Managed value stores use an address, not an object/index pair */
			if(isManagedValue)
			{
				ILGenTypeToken(info, IL_OP_LDELEMA, node->elemType);
				ILGenAdjust(info, -1);
			}

			/* Reload the values onto the stack and get the array element */
			ILGenLoadLocal(info, tempArrayVar);
			ILGenLoadLocal(info, tempIndexVar);
			ILGenAdjust(info, 2);
			ILGenLoadArray(info, machineType, node->elemType);
			ILGenAdjust(info, -1);
		}

		/* Release the temporary variables */
		ILGenReleaseTempVar(info, tempArrayVar);
		ILGenReleaseTempVar(info, tempIndexVar);
	}
	else
	{
		/* Get temporary variables for the array and the indices */
		tempArrayVar = ILGenTempTypedVar(info, node->arrayType);
		rank = ILTypeGetRank(node->arrayType);
		tempIndexVars = (unsigned *)ILMalloc(sizeof(unsigned) * rank);
		if(!tempIndexVars)
		{
			ILGenOutOfMemory(info);
		}
		for(dim = 0; dim < rank; ++dim)
		{
			tempIndexVars[dim] = ILGenTempTypedVar(info, ILType_Int32);
		}

		/* Get the array reference and save it */
		ILNode_GenValue(node->array, info);
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
		ILGenStoreLocal(info, tempArrayVar);
		ILGenAdjust(info, -1);

		/* Get the index values and save them */
		for(dim = 0; dim < rank; ++dim)
		{
			posn = rank - dim;
			indexNode = node->indices;
			while(posn > 1)
			{
				indexNode = ((ILNode_ArgList *)indexNode)->expr1;
				--posn;
			}
			if(yyisa(indexNode, ILNode_ArgList))
			{
				indexNode = ((ILNode_ArgList *)indexNode)->expr2;
			}
			ILNode_GenValue(indexNode, info);
			ILGenSimple(info, IL_OP_DUP);
			ILGenAdjust(info, 1);
			ILGenStoreLocal(info, tempIndexVars[dim]);
			ILGenAdjust(info, -1);
		}

		/* Do we need to leave the current value on the stack? */
		if(leave)
		{
			/* Get the array element and save it */
			tempValueVar = ILGenTempTypedVar(info, node->elemType);
			CallMArrayMethod(info, node->arrayType, "Get");
			ILGenAdjust(info, -rank);
			ILGenSimple(info, IL_OP_DUP);
			ILGenAdjust(info, 1);
			ILGenStoreLocal(info, tempValueVar);
			ILGenAdjust(info, -1);

			/* Reload all saved values back onto the stack */
			ILGenLoadLocal(info, tempArrayVar);
			ILGenAdjust(info, 1);
			for(dim = 0; dim < rank; ++dim)
			{
				ILGenLoadLocal(info, tempIndexVars[dim]);
				ILGenAdjust(info, 1);
			}
			ILGenLoadLocal(info, tempValueVar);
			ILGenAdjust(info, 1);

			/* Account for the extra value that we will be leaving behind */
			++(node->saveStack);

			/* Release the extra temporary variable that we used */
			ILGenReleaseTempVar(info, tempValueVar);
		}
		else
		{
			/* Reload the values onto the stack and get the array element */
			ILGenLoadLocal(info, tempArrayVar);
			ILGenAdjust(info, 1);
			for(dim = 0; dim < rank; ++dim)
			{
				ILGenLoadLocal(info, tempIndexVars[dim]);
				ILGenAdjust(info, 1);
			}
			CallMArrayMethod(info, node->arrayType, "Get");
			ILGenAdjust(info, -rank);
		}

		/* Release the temporary variables */
		ILGenReleaseTempVar(info, tempArrayVar);
		for(dim = 0; dim < rank; ++dim)
		{
			ILGenReleaseTempVar(info, tempIndexVars[dim]);
		}
		ILFree(tempIndexVars);
	}
	return machineType;
}
#line 927 "cg_lvalue.c"

void ILNode_ArrayAccess_ILNode_Store__(ILNode_ArrayAccess *node, ILGenInfo * info, int leave, void * data1, void * data2)
#line 1344 "cg_lvalue.tc"
{
	ILMachineType machineType = ILTypeToMachineType(node->elemType);
	unsigned tempVar;

	/* If we need to leave the value on the stack, then temporarily
	   save it into a local variable */
	if(leave)
	{
		tempVar = ILGenTempTypedVar(info, node->elemType);
		ILGenSimple(info, IL_OP_DUP);
		ILGenStoreLocal(info, tempVar);
		ILGenExtend(info, 1);
	}
	else
	{
		tempVar = 0;
	}

	/* Store the value into the array */
	if(ILType_IsSimpleArray(node->arrayType))
	{
		/* We can use a simple "stelem" instruction */
		ILGenStoreArray(info, machineType, node->elemType);
	}
	else
	{
		/* We have to call a method to store the value */
		CallMArrayMethod(info, node->arrayType, "Set");
	}

	/* Reset the stack to its original position */
	info->stackHeight = node->saveStack;

	/* Push the left value back onto the stack if necessary */
	if(leave)
	{
		ILGenLoadLocal(info, tempVar);
		ILGenAdjust(info, 1);
		ILGenReleaseTempVar(info, tempVar);
	}
}
#line 972 "cg_lvalue.c"

void ILNode_ArrayAccess_ILNode_GenRef__(ILNode_ArrayAccess *node, ILGenInfo * info)
#line 1509 "cg_lvalue.tc"
{
	long saveStack;
	if(ILType_IsSimpleArray(node->arrayType))
	{
		/* We can use the "ldelema" instruction */
		ILNode_GenValue(node->array, info);
		ILNode_GenValue(node->indices, info);
		ILGenTypeToken(info, IL_OP_LDELEMA, node->elemType);
		ILGenAdjust(info, -1);
	}
	else
	{
		/* We have to call a method to get the address */
		saveStack = info->stackHeight;
		ILNode_GenValue(node->array, info);
		ILNode_GenValue(node->indices, info);
		CallMArrayMethod(info, node->arrayType, "Address");
		info->stackHeight = saveStack + 1;
	}
}
#line 996 "cg_lvalue.c"

struct ILNode_ArrayAccess_vtable__ const ILNode_ArrayAccess_vt__ = {
	&ILNode_LValue_vt__,
	ILNode_ArrayAccess_kind,
	"ILNode_ArrayAccess",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_ArrayAccess_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_ArrayAccess_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_ArrayAccess_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Expression_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, void * * data1, void * * data2))ILNode_ArrayAccess_ILNode_Prepare__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * * data1, void * * data2))ILNode_ArrayAccess_ILNode_GetAndPrepare__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * data1, void * data2))ILNode_ArrayAccess_ILNode_Store__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info))ILNode_ArrayAccess_ILNode_GenRef__,
};

ILMachineType ILNode_StaticProperty_ILNode_GetType__(ILNode_StaticProperty *node, ILGenInfo * info)
#line 95 "cg_lvalue.tc"
{
	ILType *signature = ILProperty_Signature(node->property);
	return ILTypeToMachineType(ILTypeGetReturn(signature));
}
#line 1021 "cg_lvalue.c"

void ILNode_StaticProperty_ILNode_GenDiscard__(ILNode_StaticProperty *node, ILGenInfo * info)
#line 157 "cg_lvalue.tc"
{
	/* Nothing to do here */
}
#line 1028 "cg_lvalue.c"

ILMachineType ILNode_StaticProperty_ILNode_GenValue__(ILNode_StaticProperty *node, ILGenInfo * info)
#line 301 "cg_lvalue.tc"
{
	ILMethod *getter = ILProperty_Getter(node->property);
	ILType *signature = ILProperty_Signature(node->property);
	ILGenCallMethod(info, getter);
	ILGenAdjust(info, 1);
	return ILTypeToMachineType(ILTypeGetReturn(signature));
}
#line 1039 "cg_lvalue.c"

ILMachineType ILNode_StaticProperty_ILNode_Prepare__(ILNode_StaticProperty *node, ILGenInfo * info, void * * data1, void * * data2)
#line 486 "cg_lvalue.tc"
{
	ILType *signature = ILProperty_Signature(node->property);
	return ILTypeToMachineType(ILTypeGetReturn(signature));
}
#line 1047 "cg_lvalue.c"

ILMachineType ILNode_StaticProperty_ILNode_GetAndPrepare__(ILNode_StaticProperty *node, ILGenInfo * info, int leave, void * * data1, void * * data2)
#line 720 "cg_lvalue.tc"
{
	ILMethod *getter = ILProperty_Getter(node->property);
	ILType *signature = ILProperty_Signature(node->property);
	ILGenCallMethod(info, getter);
	ILGenAdjust(info, 1);
	if(leave)
	{
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
	}
	return ILTypeToMachineType(ILTypeGetReturn(signature));
}
#line 1063 "cg_lvalue.c"

void ILNode_StaticProperty_ILNode_Store__(ILNode_StaticProperty *node, ILGenInfo * info, int leave, void * data1, void * data2)
#line 1267 "cg_lvalue.tc"
{
	ILMethod *setter = ILProperty_Setter(node->property);
	if(leave)
	{
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
	}
	ILGenCallMethod(info, setter);
	ILGenAdjust(info, -1);
}
#line 1077 "cg_lvalue.c"

struct ILNode_StaticProperty_vtable__ const ILNode_StaticProperty_vt__ = {
	&ILNode_LValueNoRef_vt__,
	ILNode_StaticProperty_kind,
	"ILNode_StaticProperty",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_StaticProperty_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_StaticProperty_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_StaticProperty_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Expression_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, void * * data1, void * * data2))ILNode_StaticProperty_ILNode_Prepare__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * * data1, void * * data2))ILNode_StaticProperty_ILNode_GetAndPrepare__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * data1, void * data2))ILNode_StaticProperty_ILNode_Store__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info))ILNode_LValueNoRef_ILNode_GenRef__,
};

ILMachineType ILNode_MemberProperty_ILNode_GetType__(ILNode_MemberProperty *node, ILGenInfo * info)
#line 95 "cg_lvalue.tc"
{
	ILType *signature = ILProperty_Signature(node->property);
	return ILTypeToMachineType(ILTypeGetReturn(signature));
}
#line 1102 "cg_lvalue.c"

ILMachineType ILNode_MemberProperty_ILNode_GenValue__(ILNode_MemberProperty *node, ILGenInfo * info)
#line 313 "cg_lvalue.tc"
{
	ILMethod *getter = ILProperty_Getter(node->property);
	ILType *signature = ILProperty_Signature(node->property);
	unsigned tempVar = ILGenPrepareForThisAccess
		(info, node->expr, ILProperty_Owner(node->property), 0);
	if(node->baseCall)
	{
		ILGenCallByMethod(info, getter);
	}
	else
	{
		ILGenCallMethod(info,getter);
	}
	ILGenFreeThisVar(info, tempVar);
	return ILTypeToMachineType(ILTypeGetReturn(signature));
}
#line 1122 "cg_lvalue.c"

ILMachineType ILNode_MemberProperty_ILNode_Prepare__(ILNode_MemberProperty *node, ILGenInfo * info, void * * data1, void * * data2)
#line 495 "cg_lvalue.tc"
{
	ILType *signature = ILProperty_Signature(node->property);
	node->tempVar = IL_MAX_UINT32;
	ILGenPrepareForThisAccess(info, node->expr,
							  ILProperty_Owner(node->property), 0);
	return ILTypeToMachineType(ILTypeGetReturn(signature));
}
#line 1133 "cg_lvalue.c"

ILMachineType ILNode_MemberProperty_ILNode_GetAndPrepare__(ILNode_MemberProperty *node, ILGenInfo * info, int leave, void * * data1, void * * data2)
#line 737 "cg_lvalue.tc"
{
	ILMethod *getter = ILProperty_Getter(node->property);
	ILType *signature = ILProperty_Signature(node->property);
	ILType *propType = ILTypeGetReturn(signature);
	if(leave)
	{
		/* Generate the object reference */
		ILGenPrepareForThisAccess(info, node->expr,
								  ILProperty_Owner(node->property), 0);

		/* Duplicate it and get the current value */
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
		if(node->baseCall)
		{
			ILGenCallByMethod(info, getter);
		}
		else
		{
			ILGenCallMethod(info, getter);
		}

		/* Store the current value into a temporary local */
		node->tempVar = ILGenTempTypedVar(info, propType);
		ILGenSimple(info, IL_OP_DUP);
		ILGenStoreLocal(info, node->tempVar);
		ILGenExtend(info, 1);
	}
	else
	{
		/* Generate the object reference */
		ILGenPrepareForThisAccess(info, node->expr,
								  ILProperty_Owner(node->property), 0);

		/* Duplicate it for the later store */
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);

		/* Load the current value from the property */
		if(node->baseCall)
		{
			ILGenCallByMethod(info, getter);
		}
		else
		{
			ILGenCallMethod(info, getter);
		}

		/* We don't need to reload a previous value in "Store" */
		node->tempVar = IL_MAX_UINT32;
	}
	return ILTypeToMachineType(propType);
}
#line 1190 "cg_lvalue.c"

void ILNode_MemberProperty_ILNode_Store__(ILNode_MemberProperty *node, ILGenInfo * info, int leave, void * data1, void * data2)
#line 1282 "cg_lvalue.tc"
{
	ILMethod *setter = ILProperty_Setter(node->property);
	ILType *signature = ILProperty_Signature(node->property);
	ILType *propType = ILTypeGetReturn(signature);
	if(leave)
	{
		/* Copy the result into a temporary local */
		unsigned temp = ILGenTempTypedVar(info, propType);
		ILGenSimple(info, IL_OP_DUP);
		ILGenStoreLocal(info, temp);
		ILGenExtend(info, 1);
		if(node->baseCall)
		{
			ILGenCallByMethod(info,setter);
		}
		else
		{
			/* Store the value into the property */
			ILGenCallMethod(info, setter);
		}
		ILGenAdjust(info, -2);

		/* Do we need to restore a previous value to the stack top? */
		if(node->tempVar != IL_MAX_UINT32)
		{
			ILGenLoadLocal(info, node->tempVar);
			ILGenAdjust(info, 1);
			ILGenReleaseTempVar(info, node->tempVar);
		}

		/* Reload the contents of the temporary local */
		ILGenLoadLocal(info, temp);
		ILGenAdjust(info, 1);
		ILGenReleaseTempVar(info, temp);
	}
	else
	{
		/* Store the value into the property */
		if(node->baseCall)
		{
			ILGenCallByMethod(info, setter);
		}
		else
		{
			ILGenCallMethod(info, setter);
		}
		ILGenAdjust(info, -2);

		/* Do we need to restore a previous value to the stack top? */
		if(node->tempVar != IL_MAX_UINT32)
		{
			ILGenLoadLocal(info, node->tempVar);
			ILGenAdjust(info, 1);
			ILGenReleaseTempVar(info, node->tempVar);
		}
	}
}
#line 1251 "cg_lvalue.c"

struct ILNode_MemberProperty_vtable__ const ILNode_MemberProperty_vt__ = {
	&ILNode_LValueNoRef_vt__,
	ILNode_MemberProperty_kind,
	"ILNode_MemberProperty",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_MemberProperty_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Expression_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_MemberProperty_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Expression_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, void * * data1, void * * data2))ILNode_MemberProperty_ILNode_Prepare__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * * data1, void * * data2))ILNode_MemberProperty_ILNode_GetAndPrepare__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * data1, void * data2))ILNode_MemberProperty_ILNode_Store__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info))ILNode_LValueNoRef_ILNode_GenRef__,
};

ILMachineType ILNode_IndexerAccess_ILNode_GetType__(ILNode_IndexerAccess *node, ILGenInfo * info)
#line 112 "cg_lvalue.tc"
{
	return node->machineType;
}
#line 1275 "cg_lvalue.c"

void ILNode_IndexerAccess_ILNode_GenDiscard__(ILNode_IndexerAccess *node, ILGenInfo * info)
#line 174 "cg_lvalue.tc"
{
	ILNode_GenDiscard(node->object, info);
	ILNode_GenDiscard(node->indices, info);
}
#line 1283 "cg_lvalue.c"

ILMachineType ILNode_IndexerAccess_ILNode_GenValue__(ILNode_IndexerAccess *node, ILGenInfo * info)
#line 389 "cg_lvalue.tc"
{
	long saveStack = info->stackHeight;
	ILNode_GenValue(node->object, info);
	ILNode_GenValue(node->indices, info);
	if(node->baseAccess)
	{
		ILGenCallByMethod(info, node->getMethod);
	}
	else
	{
		ILGenCallMethod(info, node->getMethod);
	}
	info->stackHeight = saveStack + 1;
	return node->machineType;
}
#line 1302 "cg_lvalue.c"

ILMachineType ILNode_IndexerAccess_ILNode_Prepare__(ILNode_IndexerAccess *node, ILGenInfo * info, void * * data1, void * * data2)
#line 535 "cg_lvalue.tc"
{
	node->saveStack = info->stackHeight;
	ILNode_GenValue(node->object, info);
	ILNode_GenValue(node->indices, info);
	return node->machineType;
}
#line 1312 "cg_lvalue.c"

ILMachineType ILNode_IndexerAccess_ILNode_GetAndPrepare__(ILNode_IndexerAccess *node, ILGenInfo * info, int leave, void * * data1, void * * data2)
#line 985 "cg_lvalue.tc"
{
	unsigned tempObjectVar;
	unsigned tempValueVar;
	unsigned *tempIndexVars;
	int numArgs, argNum, posn;
	ILNode *indexNode;
	ILType *signature;

	/* Save the current stack position so "Store" knows what to pop */
	node->saveStack = info->stackHeight;

	/* Get the signature for the "get" method, so that we know
	   what types to use to temporarily save the index values */
	signature = ILMethod_Signature(node->getMethod);

	/* Get temporary variables for the object and the indices */
	tempObjectVar = ILGenTempTypedVar(info, node->objectType);
	numArgs = 1;
	indexNode = node->indices;
	while(yyisa(indexNode, ILNode_ArgList))
	{
		++numArgs;
		indexNode = ((ILNode_ArgList *)indexNode)->expr1;
	}
	tempIndexVars = (unsigned *)ILMalloc(sizeof(unsigned) * numArgs);
	if(!tempIndexVars)
	{
		ILGenOutOfMemory(info);
	}
	for(argNum = 0; argNum < numArgs; ++argNum)
	{
		tempIndexVars[argNum] = ILGenTempTypedVar
				(info, ILTypeGetParam(signature, argNum + 1));
	}

	/* Get the object reference and save it */
	ILNode_GenValue(node->object, info);
	ILGenSimple(info, IL_OP_DUP);
	ILGenAdjust(info, 1);
	ILGenStoreLocal(info, tempObjectVar);
	ILGenAdjust(info, -1);

	/* Get the index values and save them */
	for(argNum = 0; argNum < numArgs; ++argNum)
	{
		posn = numArgs - argNum;
		indexNode = node->indices;
		while(posn > 1)
		{
			indexNode = ((ILNode_ArgList *)indexNode)->expr1;
			--posn;
		}
		if(yyisa(indexNode, ILNode_ArgList))
		{
			indexNode = ((ILNode_ArgList *)indexNode)->expr2;
		}
		ILNode_GenValue(indexNode, info);
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
		ILGenStoreLocal(info, tempIndexVars[argNum]);
		ILGenAdjust(info, -1);
	}

	/* Do we need to leave the current value on the stack? */
	if(leave)
	{
		/* Get the indexer element and save it */
		tempValueVar = ILGenTempTypedVar(info, node->elemType);
		if(node->baseAccess)
		{
			ILGenCallByMethod(info, node->getMethod);
		}
		else
		{
			ILGenCallMethod(info, node->getMethod);
		}
		ILGenAdjust(info, -numArgs);
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
		ILGenStoreLocal(info, tempValueVar);
		ILGenAdjust(info, -1);

		/* Reload all saved values back onto the stack */
		ILGenLoadLocal(info, tempObjectVar);
		ILGenAdjust(info, 1);
		for(argNum = 0; argNum < numArgs; ++argNum)
		{
			ILGenLoadLocal(info, tempIndexVars[argNum]);
			ILGenAdjust(info, 1);
		}
		ILGenLoadLocal(info, tempValueVar);
		ILGenAdjust(info, 1);

		/* Account for the extra value that we will be leaving behind */
		++(node->saveStack);

		/* Release the extra temporary variable that we used */
		ILGenReleaseTempVar(info, tempValueVar);
	}
	else
	{
		/* Reload the values onto the stack and get the indexer element */
		ILGenLoadLocal(info, tempObjectVar);
		ILGenAdjust(info, 1);
		for(argNum = 0; argNum < numArgs; ++argNum)
		{
			ILGenLoadLocal(info, tempIndexVars[argNum]);
			ILGenAdjust(info, 1);
		}
		if(node->baseAccess)
		{
			ILGenCallByMethod(info, node->getMethod);
		}
		else
		{
			ILGenCallMethod(info, node->getMethod);
		}
		ILGenAdjust(info, -numArgs);
	}

	/* Release the temporary variables */
	ILGenReleaseTempVar(info, tempObjectVar);
	for(argNum = 0; argNum < numArgs; ++argNum)
	{
		ILGenReleaseTempVar(info, tempIndexVars[argNum]);
	}
	ILFree(tempIndexVars);
	return node->machineType;
}
#line 1445 "cg_lvalue.c"

void ILNode_IndexerAccess_ILNode_Store__(ILNode_IndexerAccess *node, ILGenInfo * info, int leave, void * data1, void * data2)
#line 1390 "cg_lvalue.tc"
{
	if(leave)
	{
		unsigned tempVar = ILGenTempTypedVar(info, node->elemType);
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
		ILGenStoreLocal(info, tempVar);
		ILGenAdjust(info, -1);
		if(node->baseAccess)
		{
			ILGenCallByMethod(info, node->setMethod);
		}
		else
		{
			ILGenCallMethod(info, node->setMethod);
		}
		info->stackHeight = node->saveStack;
		ILGenLoadLocal(info, tempVar);
		ILGenAdjust(info, 1);
		ILGenReleaseTempVar(info, tempVar);
	}
	else
	{
		if(node->baseAccess)
		{
			ILGenCallByMethod(info, node->setMethod);
		}
		else
		{
			ILGenCallMethod(info, node->setMethod);
		}
		info->stackHeight = node->saveStack;
	}
}
#line 1483 "cg_lvalue.c"

struct ILNode_IndexerAccess_vtable__ const ILNode_IndexerAccess_vt__ = {
	&ILNode_LValueNoRef_vt__,
	ILNode_IndexerAccess_kind,
	"ILNode_IndexerAccess",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_IndexerAccess_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_IndexerAccess_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_IndexerAccess_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Expression_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, void * * data1, void * * data2))ILNode_IndexerAccess_ILNode_Prepare__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * * data1, void * * data2))ILNode_IndexerAccess_ILNode_GetAndPrepare__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * data1, void * data2))ILNode_IndexerAccess_ILNode_Store__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info))ILNode_LValueNoRef_ILNode_GenRef__,
};

ILMachineType ILNode_BaseAccess_ILNode_GetType__(ILNode_BaseAccess *node, ILGenInfo * info)
#line 77 "cg_lvalue.tc"
{
	return node->machineType;
}
#line 1507 "cg_lvalue.c"

void ILNode_BaseAccess_ILNode_GenDiscard__(ILNode_BaseAccess *node, ILGenInfo * info)
#line 139 "cg_lvalue.tc"
{
	/* Nothing needs to be done here */
}
#line 1514 "cg_lvalue.c"

ILMachineType ILNode_BaseAccess_ILNode_GenValue__(ILNode_BaseAccess *node, ILGenInfo * info)
#line 228 "cg_lvalue.tc"
{
 	ILClass *classInfo = ((ILNode_ClassDefn *)(info->currentClass))
 									->classInfo;
 	ILType *type =ILClassToType(ILClass_Parent(classInfo));
 	ILMachineType machineType;
 
 	/* Do we need to unpack a value type instance? */
 	if(ILTypeIsValue(type))
 	{
 		/* Push the managed pointer in "this" onto the stack */
 		ILGenSimple(info, IL_OP_LDARG_0);
 		ILGenAdjust(info, 1);
 
 		/* Load the value from the managed pointer */
 		machineType = ILTypeToMachineType(type);
 		ILGenLoadManaged(info, machineType, type);
 		return machineType;
 	}
 	else
 	{
 		/* We assume that "this" is an object reference in argument 0 */
 		ILGenSimple(info, IL_OP_LDARG_0);
 		ILGenAdjust(info, 1);
 		return ILMachineType_ObjectRef;
 	}
	return node->machineType;
}
#line 1545 "cg_lvalue.c"

ILMachineType ILNode_BaseAccess_ILNode_Prepare__(ILNode_BaseAccess *node, ILGenInfo * info, void * * data1, void * * data2)
#line 439 "cg_lvalue.tc"
{
	/* Pseudo node - replaced during semantic analysis */
	return node->machineType;
}
#line 1553 "cg_lvalue.c"

ILMachineType ILNode_BaseAccess_ILNode_GetAndPrepare__(ILNode_BaseAccess *node, ILGenInfo * info, int leave, void * * data1, void * * data2)
#line 616 "cg_lvalue.tc"
{
	/* Pseudo node - replaced during semantic analysis */
	return node->machineType;
}
#line 1561 "cg_lvalue.c"

void ILNode_BaseAccess_ILNode_Store__(ILNode_BaseAccess *node, ILGenInfo * info, int leave, void * data1, void * data2)
#line 1190 "cg_lvalue.tc"
{
	/* Should be handled by IndexerAccess */
}
#line 1568 "cg_lvalue.c"

void ILNode_BaseAccess_ILNode_GenRef__(ILNode_BaseAccess *node, ILGenInfo * info)
#line 1484 "cg_lvalue.tc"
{
	/* Pseudo node - replaced during semantic analysis */
}
#line 1575 "cg_lvalue.c"

struct ILNode_BaseAccess_vtable__ const ILNode_BaseAccess_vt__ = {
	&ILNode_LValueUnaryExpr_vt__,
	ILNode_BaseAccess_kind,
	"ILNode_BaseAccess",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_BaseAccess_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_BaseAccess_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_BaseAccess_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Expression_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, void * * data1, void * * data2))ILNode_BaseAccess_ILNode_Prepare__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * * data1, void * * data2))ILNode_BaseAccess_ILNode_GetAndPrepare__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * data1, void * data2))ILNode_BaseAccess_ILNode_Store__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info))ILNode_BaseAccess_ILNode_GenRef__,
};

ILMachineType ILNode_BaseElement_ILNode_GetType__(ILNode_BaseElement *node, ILGenInfo * info)
#line 77 "cg_lvalue.tc"
{
	return node->machineType;
}
#line 1599 "cg_lvalue.c"

ILMachineType ILNode_BaseElement_ILNode_GenValue__(ILNode_BaseElement *node, ILGenInfo * info)
#line 260 "cg_lvalue.tc"
{
	/* Should be handled by IndexerAccess */
	return node->machineType;
}
#line 1607 "cg_lvalue.c"

ILMachineType ILNode_BaseElement_ILNode_Prepare__(ILNode_BaseElement *node, ILGenInfo * info, void * * data1, void * * data2)
#line 448 "cg_lvalue.tc"
{
	/* Should be handled by IndexerAccess */
	return node->machineType;
}
#line 1615 "cg_lvalue.c"

ILMachineType ILNode_BaseElement_ILNode_GetAndPrepare__(ILNode_BaseElement *node, ILGenInfo * info, int leave, void * * data1, void * * data2)
#line 625 "cg_lvalue.tc"
{
	/* Should be handled by IndexerAccess */
	return node->machineType;
}
#line 1623 "cg_lvalue.c"

void ILNode_BaseElement_ILNode_Store__(ILNode_BaseElement *node, ILGenInfo * info, int leave, void * data1, void * data2)
#line 1198 "cg_lvalue.tc"
{
	/* Should be handled by IndexerAccess */
}
#line 1630 "cg_lvalue.c"

void ILNode_BaseElement_ILNode_GenRef__(ILNode_BaseElement *node, ILGenInfo * info)
#line 1492 "cg_lvalue.tc"
{
	/* Should be handled by IndexerAccess */
}
#line 1637 "cg_lvalue.c"

struct ILNode_BaseElement_vtable__ const ILNode_BaseElement_vt__ = {
	&ILNode_LValueUnaryExpr_vt__,
	ILNode_BaseElement_kind,
	"ILNode_BaseElement",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_BaseElement_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Expression_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_BaseElement_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Expression_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, void * * data1, void * * data2))ILNode_BaseElement_ILNode_Prepare__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * * data1, void * * data2))ILNode_BaseElement_ILNode_GetAndPrepare__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * data1, void * data2))ILNode_BaseElement_ILNode_Store__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info))ILNode_BaseElement_ILNode_GenRef__,
};

ILMachineType ILNode_MemberAccess_ILNode_GetType__(ILNode_MemberAccess *node, ILGenInfo * info)
#line 77 "cg_lvalue.tc"
{
	return node->machineType;
}
#line 1661 "cg_lvalue.c"

void ILNode_MemberAccess_ILNode_GenDiscard__(ILNode_MemberAccess *node, ILGenInfo * info)
#line 130 "cg_lvalue.tc"
{
	/* Evaluate the object expression for its side-effects */
	ILNode_GenDiscard(node->expr1, info);
}
#line 1669 "cg_lvalue.c"

ILMachineType ILNode_MemberAccess_ILNode_GenValue__(ILNode_MemberAccess *node, ILGenInfo * info)
#line 219 "cg_lvalue.tc"
{
	/* Pseudo node - replaced during semantic analysis */
	return node->machineType;
}
#line 1677 "cg_lvalue.c"

ILMachineType ILNode_MemberAccess_ILNode_Prepare__(ILNode_MemberAccess *node, ILGenInfo * info, void * * data1, void * * data2)
#line 430 "cg_lvalue.tc"
{
	/* Pseudo node - replaced during semantic analysis */
	return node->machineType;
}
#line 1685 "cg_lvalue.c"

ILMachineType ILNode_MemberAccess_ILNode_GetAndPrepare__(ILNode_MemberAccess *node, ILGenInfo * info, int leave, void * * data1, void * * data2)
#line 607 "cg_lvalue.tc"
{
	/* Pseudo node - replaced during semantic analysis */
	return node->machineType;
}
#line 1693 "cg_lvalue.c"

void ILNode_MemberAccess_ILNode_Store__(ILNode_MemberAccess *node, ILGenInfo * info, int leave, void * data1, void * data2)
#line 1182 "cg_lvalue.tc"
{
	/* Pseudo node - replaced during semantic analysis */
}
#line 1700 "cg_lvalue.c"

void ILNode_MemberAccess_ILNode_GenRef__(ILNode_MemberAccess *node, ILGenInfo * info)
#line 1476 "cg_lvalue.tc"
{
	/* Pseudo node - replaced during semantic analysis */
}
#line 1707 "cg_lvalue.c"

struct ILNode_MemberAccess_vtable__ const ILNode_MemberAccess_vt__ = {
	&ILNode_LValueBinaryExpr_vt__,
	ILNode_MemberAccess_kind,
	"ILNode_MemberAccess",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_MemberAccess_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_MemberAccess_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_MemberAccess_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Expression_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, void * * data1, void * * data2))ILNode_MemberAccess_ILNode_Prepare__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * * data1, void * * data2))ILNode_MemberAccess_ILNode_GetAndPrepare__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * data1, void * data2))ILNode_MemberAccess_ILNode_Store__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info))ILNode_MemberAccess_ILNode_GenRef__,
};

ILMachineType ILNode_DerefField_ILNode_GetType__(ILNode_DerefField *node, ILGenInfo * info)
#line 77 "cg_lvalue.tc"
{
	return node->machineType;
}
#line 1731 "cg_lvalue.c"

void ILNode_DerefField_ILNode_GenDiscard__(ILNode_DerefField *node, ILGenInfo * info)
#line 147 "cg_lvalue.tc"
{
	/* Evaluate the object expression for its side-effects */
	ILNode_GenDiscard(node->expr1, info);
}
#line 1739 "cg_lvalue.c"

ILMachineType ILNode_DerefField_ILNode_GenValue__(ILNode_DerefField *node, ILGenInfo * info)
#line 269 "cg_lvalue.tc"
{
	ILNode_GenValue(node->expr1, info);
	ILGenFieldRef(info, IL_OP_LDFLD, node->field);
	return node->machineType;
}
#line 1748 "cg_lvalue.c"

ILMachineType ILNode_DerefField_ILNode_Prepare__(ILNode_DerefField *node, ILGenInfo * info, void * * data1, void * * data2)
#line 457 "cg_lvalue.tc"
{
	ILNode_GenValue(node->expr1, info);
	node->tempVar = IL_MAX_UINT32;
	return node->machineType;
}
#line 1757 "cg_lvalue.c"

ILMachineType ILNode_DerefField_ILNode_GetAndPrepare__(ILNode_DerefField *node, ILGenInfo * info, int leave, void * * data1, void * * data2)
#line 634 "cg_lvalue.tc"
{
	ILNode_GenValue(node->expr1, info);
	if(leave)
	{
		/* Duplicate the pointer reference and get the current value */
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);
		ILGenFieldRef(info, IL_OP_LDFLD, node->field);

		/* Store the current value into a temporary local */
		node->tempVar = ILGenTempTypedVar(info, ILField_Type(node->field));
		ILGenSimple(info, IL_OP_DUP);
		ILGenStoreLocal(info, node->tempVar);
		ILGenExtend(info, 1);
	}
	else
	{
		/* Duplicate the pointer reference for the later store */
		ILGenSimple(info, IL_OP_DUP);
		ILGenAdjust(info, 1);

		/* Load the current value from the field */
		ILGenFieldRef(info, IL_OP_LDFLD, node->field);

		/* We don't need to reload a previous value in "Store" */
		node->tempVar = IL_MAX_UINT32;
	}
	return node->machineType;
}
#line 1790 "cg_lvalue.c"

void ILNode_DerefField_ILNode_Store__(ILNode_DerefField *node, ILGenInfo * info, int leave, void * data1, void * data2)
#line 1221 "cg_lvalue.tc"
{
	if(leave)
	{
		/* Copy the result into a temporary local */
		unsigned temp = ILGenTempTypedVar(info, ILField_Type(node->field));
		ILGenSimple(info, IL_OP_DUP);
		ILGenStoreLocal(info, temp);
		ILGenExtend(info, 1);

		/* Store the value into the field */
		ILGenFieldRef(info, IL_OP_STFLD, node->field);
		ILGenAdjust(info, -2);

		/* Do we need to restore a previous value to the stack top? */
		if(node->tempVar != IL_MAX_UINT32)
		{
			ILGenLoadLocal(info, node->tempVar);
			ILGenAdjust(info, 1);
			ILGenReleaseTempVar(info, node->tempVar);
		}

		/* Reload the contents of the temporary local */
		ILGenLoadLocal(info, temp);
		ILGenAdjust(info, 1);
		ILGenReleaseTempVar(info, temp);
	}
	else
	{
		/* Store the value into the field */
		ILGenFieldRef(info, IL_OP_STFLD, node->field);
		ILGenAdjust(info, -2);

		/* Do we need to restore a previous value to the stack top? */
		if(node->tempVar != IL_MAX_UINT32)
		{
			ILGenLoadLocal(info, node->tempVar);
			ILGenAdjust(info, 1);
			ILGenReleaseTempVar(info, node->tempVar);
		}
	}
}
#line 1835 "cg_lvalue.c"

void ILNode_DerefField_ILNode_GenRef__(ILNode_DerefField *node, ILGenInfo * info)
#line 1500 "cg_lvalue.tc"
{
	ILNode_GenValue(node->expr1, info);
	ILGenFieldRef(info, IL_OP_LDFLDA, node->field);
}
#line 1843 "cg_lvalue.c"

struct ILNode_DerefField_vtable__ const ILNode_DerefField_vt__ = {
	&ILNode_LValueBinaryExpr_vt__,
	ILNode_DerefField_kind,
	"ILNode_DerefField",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_DerefField_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_DerefField_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_DerefField_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Expression_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Expression_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, void * * data1, void * * data2))ILNode_DerefField_ILNode_Prepare__,
	(ILMachineType (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * * data1, void * * data2))ILNode_DerefField_ILNode_GetAndPrepare__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info, int leave, void * data1, void * data2))ILNode_DerefField_ILNode_Store__,
	(void (*)(ILNode_LValue *this__, ILGenInfo * info))ILNode_DerefField_ILNode_GenRef__,
};

ILNode *ILNode_Identifier_create(char * name)
{
	ILNode_Identifier *node__ = (ILNode_Identifier *)yynodealloc(sizeof(struct ILNode_Identifier__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_Identifier_vt__;
	node__->kind__ = ILNode_Identifier_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->name = name;
	return (ILNode *)node__;
}

ILNode *ILNode_QualIdent_create(ILNode * left, ILNode * right)
{
	ILNode_QualIdent *node__ = (ILNode_QualIdent *)yynodealloc(sizeof(struct ILNode_QualIdent__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_QualIdent_vt__;
	node__->kind__ = ILNode_QualIdent_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->left = left;
	node__->right = right;
	return (ILNode *)node__;
}

ILNode *ILNode_LocalVar_create(unsigned long index, ILMachineType machineType)
{
	ILNode_LocalVar *node__ = (ILNode_LocalVar *)yynodealloc(sizeof(struct ILNode_LocalVar__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_LocalVar_vt__;
	node__->kind__ = ILNode_LocalVar_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->index = index;
	node__->machineType = machineType;
	return (ILNode *)node__;
}

ILNode *ILNode_ArgumentVar_create(unsigned long index, ILMachineType machineType)
{
	ILNode_ArgumentVar *node__ = (ILNode_ArgumentVar *)yynodealloc(sizeof(struct ILNode_ArgumentVar__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_ArgumentVar_vt__;
	node__->kind__ = ILNode_ArgumentVar_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->index = index;
	node__->machineType = machineType;
	return (ILNode *)node__;
}

ILNode *ILNode_RefArgumentVar_create(unsigned long index, ILMachineType machineType, ILType * type)
{
	ILNode_RefArgumentVar *node__ = (ILNode_RefArgumentVar *)yynodealloc(sizeof(struct ILNode_RefArgumentVar__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_RefArgumentVar_vt__;
	node__->kind__ = ILNode_RefArgumentVar_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->index = index;
	node__->machineType = machineType;
	node__->type = type;
	return (ILNode *)node__;
}

ILNode *ILNode_StaticField_create(ILField * field)
{
	ILNode_StaticField *node__ = (ILNode_StaticField *)yynodealloc(sizeof(struct ILNode_StaticField__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_StaticField_vt__;
	node__->kind__ = ILNode_StaticField_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->field = field;
	return (ILNode *)node__;
}

ILNode *ILNode_MemberField_create(ILNode * expr, ILField * field)
{
	ILNode_MemberField *node__ = (ILNode_MemberField *)yynodealloc(sizeof(struct ILNode_MemberField__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_MemberField_vt__;
	node__->kind__ = ILNode_MemberField_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->expr = expr;
	node__->field = field;
	node__->tempVar = 0;
	node__->baseCall = 0;
	return (ILNode *)node__;
}

ILNode *ILNode_ArrayAccess_create(ILNode * array, ILNode * indices)
{
	ILNode_ArrayAccess *node__ = (ILNode_ArrayAccess *)yynodealloc(sizeof(struct ILNode_ArrayAccess__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_ArrayAccess_vt__;
	node__->kind__ = ILNode_ArrayAccess_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->array = array;
	node__->indices = indices;
	node__->arrayType = 0;
	node__->elemType = 0;
	node__->saveStack = 0;
	return (ILNode *)node__;
}

ILNode *ILNode_StaticProperty_create(ILProperty * property)
{
	ILNode_StaticProperty *node__ = (ILNode_StaticProperty *)yynodealloc(sizeof(struct ILNode_StaticProperty__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_StaticProperty_vt__;
	node__->kind__ = ILNode_StaticProperty_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->property = property;
	node__->baseCall = 0;
	return (ILNode *)node__;
}

ILNode *ILNode_MemberProperty_create(ILNode * expr, ILProperty * property)
{
	ILNode_MemberProperty *node__ = (ILNode_MemberProperty *)yynodealloc(sizeof(struct ILNode_MemberProperty__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_MemberProperty_vt__;
	node__->kind__ = ILNode_MemberProperty_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->expr = expr;
	node__->property = property;
	node__->tempVar = 0;
	node__->baseCall = 0;
	return (ILNode *)node__;
}

ILNode *ILNode_IndexerAccess_create(ILNode * object, ILNode * indices, ILMethod * getMethod, ILMethod * setMethod, ILType * objectType, ILType * elemType, ILMachineType machineType, int baseAccess)
{
	ILNode_IndexerAccess *node__ = (ILNode_IndexerAccess *)yynodealloc(sizeof(struct ILNode_IndexerAccess__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_IndexerAccess_vt__;
	node__->kind__ = ILNode_IndexerAccess_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->object = object;
	node__->indices = indices;
	node__->getMethod = getMethod;
	node__->setMethod = setMethod;
	node__->objectType = objectType;
	node__->elemType = elemType;
	node__->machineType = machineType;
	node__->baseAccess = baseAccess;
	node__->saveStack = 0;
	return (ILNode *)node__;
}

ILNode *ILNode_BaseAccess_create(ILNode * expr)
{
	ILNode_BaseAccess *node__ = (ILNode_BaseAccess *)yynodealloc(sizeof(struct ILNode_BaseAccess__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_BaseAccess_vt__;
	node__->kind__ = ILNode_BaseAccess_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->expr = expr;
	node__->machineType = ILMachineType_Void;
	return (ILNode *)node__;
}

ILNode *ILNode_BaseElement_create(ILNode * expr)
{
	ILNode_BaseElement *node__ = (ILNode_BaseElement *)yynodealloc(sizeof(struct ILNode_BaseElement__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_BaseElement_vt__;
	node__->kind__ = ILNode_BaseElement_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->expr = expr;
	node__->machineType = ILMachineType_Void;
	return (ILNode *)node__;
}

ILNode *ILNode_MemberAccess_create(ILNode * expr1, ILNode * expr2)
{
	ILNode_MemberAccess *node__ = (ILNode_MemberAccess *)yynodealloc(sizeof(struct ILNode_MemberAccess__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_MemberAccess_vt__;
	node__->kind__ = ILNode_MemberAccess_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->expr1 = expr1;
	node__->expr2 = expr2;
	node__->machineType = ILMachineType_Void;
	return (ILNode *)node__;
}

ILNode *ILNode_DerefField_create(ILNode * expr1, ILNode * expr2)
{
	ILNode_DerefField *node__ = (ILNode_DerefField *)yynodealloc(sizeof(struct ILNode_DerefField__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_DerefField_vt__;
	node__->kind__ = ILNode_DerefField_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->expr1 = expr1;
	node__->expr2 = expr2;
	node__->machineType = ILMachineType_Void;
	node__->field = 0;
	node__->tempVar = 0;
	return (ILNode *)node__;
}

#line 1578 "cg_lvalue.tc"


ILNode *ILQualIdentSimple(char *name)
{
	return ILNode_Identifier_create(name);
}

ILNode *ILQualIdentTwo(const char *name1, const char *name2)
{
	char *intern1 = ILInternString((char *)name1, -1).string;
	char *intern2 = ILInternString((char *)name2, -1).string;
	return ILNode_QualIdent_create(ILNode_Identifier_create(intern1),
								   ILNode_Identifier_create(intern2));
}

char *ILQualIdentName(ILNode *node, int asmForm)
{
	if(!node)
	{
		return 0;
	}
	else if(yykind(node) == yykindof(ILNode_Identifier))
	{
		/* Simple name */
		ILNode_Identifier *ident = (ILNode_Identifier *)node;
		if(asmForm && ident->name[0] >= 'a' && ident->name[0] <= 'z')
		{
			/* The name might clash with an assembler keyword
			   or instruction name, so we must quote it */
			ILIntString quote = ILInternString("'", 1);
			ILIntString name;
			name.string = ident->name;
			name.len = strlen(ident->name);
			return (ILInternAppendedString
						(quote, ILInternAppendedString(name, quote))).string;
		}
		return ident->name;
	}
	else if(yykind(node) == yykindof(ILNode_QualIdent))
	{
		/* Qualified name */
		ILNode_QualIdent *qident = (ILNode_QualIdent *)node;
		return ILQualIdentAppend(ILQualIdentName(qident->left, asmForm),
								 ILQualIdentName(qident->right, asmForm));
	}
	else
	{
		return 0;
	}
}

char *ILMemberAccessName(ILNode *node)
{
	if (!node) return 0;

	if(yykind(node) == yykindof(ILNode_Identifier))
	{
		return ((ILNode_Identifier *)node)->name;
	}
	else if(yykind(node) == yykindof(ILNode_MemberAccess))
	{
		/*  Member Access  */
		ILNode_MemberAccess *ma = (ILNode_MemberAccess *)node;
		return ILQualIdentAppend(ILMemberAccessName(ma->expr1),
								 ILMemberAccessName(ma->expr2));
	}
	else
	{
		return 0;
	}
}

char *ILQualIdentAppend(char *name1, char *name2)
{
	ILIntString str1;
	ILIntString str2;
	ILIntString str3;
	if(!name1 || *name1 == '\0' || !name2 || *name2 == '\0')
	{
		return 0;
	}
	str1.string = name1;
	str1.len = strlen(name1);
	str2.string = ".";
	str2.len = 1;
	str3.string = name2;
	str3.len = strlen(name2);
	return (ILInternAppendedString
				(str1, ILInternAppendedString(str2, str3))).string;
}

int ILIsQualIdent(ILNode *node)
{
	if(!node)
	{
		return 0;
	}
	if(yykind(node) == yykindof(ILNode_Identifier))
	{
		return 1;
	}
	else if(yykind(node) == yykindof(ILNode_QualIdent))
	{
		return ILIsQualIdent(((ILNode_QualIdent *)node)->left) &&
		       ILIsQualIdent(((ILNode_QualIdent *)node)->right);
	}
	else
	{
		return 0;
	}
}

#line 2187 "cg_lvalue.c"
