/* cg_const.c.  Generated automatically by treecc */
#line 3 "cg_const.tc"

/*
 * cg_const.tc - Constant value nodes.
 *
 * Copyright (C) 2001  Southern Storm Software, Pty Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <codegen/cg_nodes.h>
#line 26 "cg_const.c"

ILMachineType ILNode_Null_ILNode_GetType__(ILNode_Null *node, ILGenInfo * info)
#line 63 "cg_const.tc"
{
	return ILMachineType_ObjectRef;
}
#line 33 "cg_const.c"

ILMachineType ILNode_Null_ILNode_GenValue__(ILNode_Null *node, ILGenInfo * info)
#line 67 "cg_const.tc"
{
	ILGenSimple(info, IL_OP_LDNULL);
	ILGenAdjust(info, 1);
	return ILMachineType_ObjectRef;
}
#line 42 "cg_const.c"

void ILNode_Null_ILNode_GenThen__(ILNode_Null *node, ILGenInfo * info, ILLabel * label)
#line 55 "cg_const.tc"
{
	/* Nothing to do here */
}
#line 49 "cg_const.c"

void ILNode_Null_ILNode_GenElse__(ILNode_Null *node, ILGenInfo * info, ILLabel * label)
#line 43 "cg_const.tc"
{
	ILGenJump(info, IL_OP_BR, label);
}
#line 56 "cg_const.c"

int ILNode_Null_ILNode_EvalConst__(ILNode_Null *node, ILGenInfo * info, ILEvalValue * value)
#line 73 "cg_const.tc"
{
	value->valueType = ILMachineType_ObjectRef;
	value->un.oValue = 0;
	return 1;
}
#line 65 "cg_const.c"

struct ILNode_Null_vtable__ const ILNode_Null_vt__ = {
	&ILNode_Constant_vt__,
	ILNode_Null_kind,
	"ILNode_Null",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Null_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Null_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Null_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Null_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Null_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_NullPtr_ILNode_GetType__(ILNode_NullPtr *node, ILGenInfo * info)
#line 83 "cg_const.tc"
{
	return ILMachineType_UnmanagedPtr;
}
#line 85 "cg_const.c"

ILMachineType ILNode_NullPtr_ILNode_GenValue__(ILNode_NullPtr *node, ILGenInfo * info)
#line 87 "cg_const.tc"
{
	ILGenSimple(info, IL_OP_LDC_I4_0);
	ILGenSimple(info, IL_OP_CONV_I);
	ILGenAdjust(info, 1);
	return ILMachineType_UnmanagedPtr;
}
#line 95 "cg_const.c"

void ILNode_NullPtr_ILNode_GenThen__(ILNode_NullPtr *node, ILGenInfo * info, ILLabel * label)
#line 55 "cg_const.tc"
{
	/* Nothing to do here */
}
#line 102 "cg_const.c"

void ILNode_NullPtr_ILNode_GenElse__(ILNode_NullPtr *node, ILGenInfo * info, ILLabel * label)
#line 43 "cg_const.tc"
{
	ILGenJump(info, IL_OP_BR, label);
}
#line 109 "cg_const.c"

int ILNode_NullPtr_ILNode_EvalConst__(ILNode_NullPtr *node, ILGenInfo * info, ILEvalValue * value)
#line 94 "cg_const.tc"
{
	value->valueType = ILMachineType_UnmanagedPtr;
	value->un.i4Value = 0;
	return 1;
}
#line 118 "cg_const.c"

struct ILNode_NullPtr_vtable__ const ILNode_NullPtr_vt__ = {
	&ILNode_Constant_vt__,
	ILNode_NullPtr_kind,
	"ILNode_NullPtr",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_NullPtr_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_NullPtr_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_NullPtr_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_NullPtr_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_NullPtr_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_True_ILNode_GetType__(ILNode_True *node, ILGenInfo * info)
#line 104 "cg_const.tc"
{
	return ILMachineType_Boolean;
}
#line 138 "cg_const.c"

ILMachineType ILNode_True_ILNode_GenValue__(ILNode_True *node, ILGenInfo * info)
#line 108 "cg_const.tc"
{
	ILGenSimple(info, IL_OP_LDC_I4_1);
	ILGenAdjust(info, 1);
	return ILMachineType_Boolean;
}
#line 147 "cg_const.c"

void ILNode_True_ILNode_GenThen__(ILNode_True *node, ILGenInfo * info, ILLabel * label)
#line 43 "cg_const.tc"
{
	ILGenJump(info, IL_OP_BR, label);
}
#line 154 "cg_const.c"

void ILNode_True_ILNode_GenElse__(ILNode_True *node, ILGenInfo * info, ILLabel * label)
#line 55 "cg_const.tc"
{
	/* Nothing to do here */
}
#line 161 "cg_const.c"

int ILNode_True_ILNode_EvalConst__(ILNode_True *node, ILGenInfo * info, ILEvalValue * value)
#line 114 "cg_const.tc"
{
	value->valueType = ILMachineType_Boolean;
	value->un.i4Value = 1;
	return 1;
}
#line 170 "cg_const.c"

struct ILNode_True_vtable__ const ILNode_True_vt__ = {
	&ILNode_Constant_vt__,
	ILNode_True_kind,
	"ILNode_True",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_True_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_True_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_True_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_True_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_True_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_False_ILNode_GetType__(ILNode_False *node, ILGenInfo * info)
#line 124 "cg_const.tc"
{
	return ILMachineType_Boolean;
}
#line 190 "cg_const.c"

ILMachineType ILNode_False_ILNode_GenValue__(ILNode_False *node, ILGenInfo * info)
#line 128 "cg_const.tc"
{
	ILGenSimple(info, IL_OP_LDC_I4_0);
	ILGenAdjust(info, 1);
	return ILMachineType_Boolean;
}
#line 199 "cg_const.c"

void ILNode_False_ILNode_GenThen__(ILNode_False *node, ILGenInfo * info, ILLabel * label)
#line 55 "cg_const.tc"
{
	/* Nothing to do here */
}
#line 206 "cg_const.c"

void ILNode_False_ILNode_GenElse__(ILNode_False *node, ILGenInfo * info, ILLabel * label)
#line 43 "cg_const.tc"
{
	ILGenJump(info, IL_OP_BR, label);
}
#line 213 "cg_const.c"

int ILNode_False_ILNode_EvalConst__(ILNode_False *node, ILGenInfo * info, ILEvalValue * value)
#line 134 "cg_const.tc"
{
	value->valueType = ILMachineType_Boolean;
	value->un.i4Value = 0;
	return 1;
}
#line 222 "cg_const.c"

struct ILNode_False_vtable__ const ILNode_False_vt__ = {
	&ILNode_Constant_vt__,
	ILNode_False_kind,
	"ILNode_False",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_False_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_False_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_False_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_False_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_False_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

void ILNode_Integer_ILNode_GenThen__(ILNode_Integer *node, ILGenInfo * info, ILLabel * label)
#line 334 "cg_const.tc"
{
	if(node->value != 0)
	{
		ILGenJump(info, IL_OP_BR, label);
	}
}
#line 245 "cg_const.c"

void ILNode_Integer_ILNode_GenElse__(ILNode_Integer *node, ILGenInfo * info, ILLabel * label)
#line 341 "cg_const.tc"
{
	if(node->value == 0)
	{
		ILGenJump(info, IL_OP_BR, label);
	}
}
#line 255 "cg_const.c"

struct ILNode_Integer_vtable__ const ILNode_Integer_vt__ = {
	&ILNode_Constant_vt__,
	ILNode_Integer_kind,
	"ILNode_Integer",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))0,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))0,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Expression_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

void ILNode_Real_ILNode_GenThen__(ILNode_Real *node, ILGenInfo * info, ILLabel * label)
#line 517 "cg_const.tc"
{
	if(node->value != (ILDouble)0.0)
	{
		ILGenJump(info, IL_OP_BR, label);
	}
}
#line 278 "cg_const.c"

void ILNode_Real_ILNode_GenElse__(ILNode_Real *node, ILGenInfo * info, ILLabel * label)
#line 524 "cg_const.tc"
{
	if(node->value == (ILDouble)0.0)
	{
		ILGenJump(info, IL_OP_BR, label);
	}
}
#line 288 "cg_const.c"

struct ILNode_Real_vtable__ const ILNode_Real_vt__ = {
	&ILNode_Constant_vt__,
	ILNode_Real_kind,
	"ILNode_Real",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))0,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))0,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Real_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Real_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Expression_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_Decimal_ILNode_GetType__(ILNode_Decimal *node, ILGenInfo * info)
#line 557 "cg_const.tc"
{
	return ILMachineType_Decimal;
}
#line 308 "cg_const.c"

ILMachineType ILNode_Decimal_ILNode_GenValue__(ILNode_Decimal *node, ILGenInfo * info)
#line 561 "cg_const.tc"
{
	ILInt64 intValue;
	if(ILDecimalToInt64(&(node->value), &intValue))
	{
		/* We can up-convert an integer to get a decimal value */
		if(intValue >= (ILInt64)IL_MIN_INT32 &&
		   intValue <= (ILInt64)IL_MAX_INT32)
		{
			ILGenInt32(info, (ILInt32)intValue);
			ILGenAdjust(info, 1);
			ILGenCallByName(info, "valuetype [.library]System.Decimal "
									"[.library]System.Decimal::op_Implicit"
											"(int32)");
		}
		else if(!(info->clsCompliant) && intValue >= 0 &&
				intValue <= (ILInt64)(ILUInt64)IL_MAX_UINT32)
		{
			/* Cannot use this if CLS compliance is enabled */
			ILGenUInt32(info, (ILUInt32)intValue);
			ILGenAdjust(info, 1);
			ILGenCallByName(info, "valuetype [.library]System.Decimal "
										"[.library]System.Decimal::op_Implicit"
											"(unsigned int32)");
		}
		else
		{
			ILGenInt64(info, intValue);
			ILGenAdjust(info, 1);
			ILGenCallByName(info, "valuetype [.library]System.Decimal "
										"[.library]System.Decimal::op_Implicit"
											"(int64)");
		}
	}
	else
	{
		/* We need to call the "Decimal" constructor to get the value */
		ILGenUInt32(info, node->value.low);
		ILGenUInt32(info, node->value.middle);
		ILGenUInt32(info, node->value.high);
		ILGenUInt32(info,
				((node->value.flags & (ILUInt32)0x80000000) != 0 ? 1 : 0));
		ILGenUInt32(info, ((node->value.flags >> 16) & 0xFF));
		ILGenAdjust(info, 5);
		ILGenNewObj(info, "[.library]System.Decimal",
		            "(int32, int32, int32, bool, unsigned int8)");
		ILGenAdjust(info, -4);
	}
	return ILMachineType_Decimal;
}
#line 361 "cg_const.c"

void ILNode_Decimal_ILNode_GenThen__(ILNode_Decimal *node, ILGenInfo * info, ILLabel * label)
#line 611 "cg_const.tc"
{
	if(!ILDecimalIsZero(&(node->value)))
	{
		ILGenJump(info, IL_OP_BR, label);
	}
}
#line 371 "cg_const.c"

void ILNode_Decimal_ILNode_GenElse__(ILNode_Decimal *node, ILGenInfo * info, ILLabel * label)
#line 618 "cg_const.tc"
{
	if(ILDecimalIsZero(&(node->value)))
	{
		ILGenJump(info, IL_OP_BR, label);
	}
}
#line 381 "cg_const.c"

int ILNode_Decimal_ILNode_EvalConst__(ILNode_Decimal *node, ILGenInfo * info, ILEvalValue * value)
#line 625 "cg_const.tc"
{
	value->valueType = ILMachineType_Decimal;
	value->un.decValue = node->value;
	return 1;
}
#line 390 "cg_const.c"

struct ILNode_Decimal_vtable__ const ILNode_Decimal_vt__ = {
	&ILNode_Constant_vt__,
	ILNode_Decimal_kind,
	"ILNode_Decimal",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Decimal_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Decimal_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Decimal_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Decimal_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Decimal_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_String_ILNode_GetType__(ILNode_String *node, ILGenInfo * info)
#line 635 "cg_const.tc"
{
	return ILMachineType_String;
}
#line 410 "cg_const.c"

ILMachineType ILNode_String_ILNode_GenValue__(ILNode_String *node, ILGenInfo * info)
#line 639 "cg_const.tc"
{
	ILGenLoadString(info, node->str, node->len);
	ILGenAdjust(info, 1);
	return ILMachineType_String;
}
#line 419 "cg_const.c"

void ILNode_String_ILNode_GenThen__(ILNode_String *node, ILGenInfo * info, ILLabel * label)
#line 43 "cg_const.tc"
{
	ILGenJump(info, IL_OP_BR, label);
}
#line 426 "cg_const.c"

void ILNode_String_ILNode_GenElse__(ILNode_String *node, ILGenInfo * info, ILLabel * label)
#line 55 "cg_const.tc"
{
	/* Nothing to do here */
}
#line 433 "cg_const.c"

int ILNode_String_ILNode_EvalConst__(ILNode_String *node, ILGenInfo * info, ILEvalValue * value)
#line 645 "cg_const.tc"
{
	value->valueType = ILMachineType_String;
	value->un.strValue.str = node->str;
	value->un.strValue.len = node->len;
	return 1;
}
#line 443 "cg_const.c"

struct ILNode_String_vtable__ const ILNode_String_vt__ = {
	&ILNode_Constant_vt__,
	ILNode_String_kind,
	"ILNode_String",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_String_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_String_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_String_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_String_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_String_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_Int8_ILNode_GetType__(ILNode_Int8 *node, ILGenInfo * info)
#line 143 "cg_const.tc"
{ return ILMachineType_Int8; }
#line 461 "cg_const.c"

ILMachineType ILNode_Int8_ILNode_GenValue__(ILNode_Int8 *node, ILGenInfo * info)
#line 199 "cg_const.tc"
{
	if(node->isneg)
	{
		ILGenInt32(info, (ILInt32)(-((ILInt64)(node->value))));
	}
	else
	{
		ILGenInt32(info, (ILInt32)(node->value));
	}
	ILGenAdjust(info, 1);
	return ILMachineType_Int8;
}
#line 477 "cg_const.c"

int ILNode_Int8_ILNode_EvalConst__(ILNode_Int8 *node, ILGenInfo * info, ILEvalValue * value)
#line 352 "cg_const.tc"
{
	value->valueType = ILMachineType_Int8;
	if(node->isneg)
	{
		value->un.i4Value = (ILInt32)(-((ILInt64)(node->value)));
	}
	else
	{
		value->un.i4Value = (ILInt32)(node->value);
	}
	return 1;
}
#line 493 "cg_const.c"

struct ILNode_Int8_vtable__ const ILNode_Int8_vt__ = {
	&ILNode_Integer_vt__,
	ILNode_Int8_kind,
	"ILNode_Int8",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Int8_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Int8_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Int8_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_UInt8_ILNode_GetType__(ILNode_UInt8 *node, ILGenInfo * info)
#line 144 "cg_const.tc"
{ return ILMachineType_UInt8; }
#line 511 "cg_const.c"

ILMachineType ILNode_UInt8_ILNode_GenValue__(ILNode_UInt8 *node, ILGenInfo * info)
#line 212 "cg_const.tc"
{
	ILGenUInt32(info, (ILUInt32)(node->value));
	ILGenAdjust(info, 1);
	return ILMachineType_UInt8;
}
#line 520 "cg_const.c"

int ILNode_UInt8_ILNode_EvalConst__(ILNode_UInt8 *node, ILGenInfo * info, ILEvalValue * value)
#line 365 "cg_const.tc"
{
	value->valueType = ILMachineType_UInt8;
	value->un.i4Value = (ILInt32)(node->value);
	return 1;
}
#line 529 "cg_const.c"

struct ILNode_UInt8_vtable__ const ILNode_UInt8_vt__ = {
	&ILNode_Integer_vt__,
	ILNode_UInt8_kind,
	"ILNode_UInt8",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_UInt8_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_UInt8_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_UInt8_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_Int16_ILNode_GetType__(ILNode_Int16 *node, ILGenInfo * info)
#line 145 "cg_const.tc"
{ return ILMachineType_Int16; }
#line 547 "cg_const.c"

ILMachineType ILNode_Int16_ILNode_GenValue__(ILNode_Int16 *node, ILGenInfo * info)
#line 218 "cg_const.tc"
{
	if(node->isneg)
	{
		ILGenInt32(info, (ILInt32)(-((ILInt64)(node->value))));
	}
	else
	{
		ILGenInt32(info, (ILInt32)(node->value));
	}
	ILGenAdjust(info, 1);
	return ILMachineType_Int16;
}
#line 563 "cg_const.c"

int ILNode_Int16_ILNode_EvalConst__(ILNode_Int16 *node, ILGenInfo * info, ILEvalValue * value)
#line 371 "cg_const.tc"
{
	value->valueType = ILMachineType_Int16;
	if(node->isneg)
	{
		value->un.i4Value = (ILInt32)(-((ILInt64)(node->value)));
	}
	else
	{
		value->un.i4Value = (ILInt32)(node->value);
	}
	return 1;
}
#line 579 "cg_const.c"

struct ILNode_Int16_vtable__ const ILNode_Int16_vt__ = {
	&ILNode_Integer_vt__,
	ILNode_Int16_kind,
	"ILNode_Int16",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Int16_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Int16_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Int16_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_UInt16_ILNode_GetType__(ILNode_UInt16 *node, ILGenInfo * info)
#line 146 "cg_const.tc"
{ return ILMachineType_UInt16; }
#line 597 "cg_const.c"

ILMachineType ILNode_UInt16_ILNode_GenValue__(ILNode_UInt16 *node, ILGenInfo * info)
#line 232 "cg_const.tc"
{
	ILGenUInt32(info, (ILUInt32)(node->value));
	ILGenAdjust(info, 1);
	return ILMachineType_UInt16;
}
#line 606 "cg_const.c"

int ILNode_UInt16_ILNode_EvalConst__(ILNode_UInt16 *node, ILGenInfo * info, ILEvalValue * value)
#line 384 "cg_const.tc"
{
	value->valueType = ILMachineType_UInt16;
	value->un.i4Value = (ILInt32)(node->value);
	return 1;
}
#line 615 "cg_const.c"

struct ILNode_UInt16_vtable__ const ILNode_UInt16_vt__ = {
	&ILNode_Integer_vt__,
	ILNode_UInt16_kind,
	"ILNode_UInt16",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_UInt16_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_UInt16_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_UInt16_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_Char_ILNode_GetType__(ILNode_Char *node, ILGenInfo * info)
#line 147 "cg_const.tc"
{ return ILMachineType_Char; }
#line 633 "cg_const.c"

ILMachineType ILNode_Char_ILNode_GenValue__(ILNode_Char *node, ILGenInfo * info)
#line 232 "cg_const.tc"
{
	ILGenUInt32(info, (ILUInt32)(node->value));
	ILGenAdjust(info, 1);
	return ILMachineType_UInt16;
}
#line 642 "cg_const.c"

int ILNode_Char_ILNode_EvalConst__(ILNode_Char *node, ILGenInfo * info, ILEvalValue * value)
#line 390 "cg_const.tc"
{
	value->valueType = ILMachineType_Char;
	value->un.i4Value = (ILInt32)(node->value);
	return 1;
}
#line 651 "cg_const.c"

struct ILNode_Char_vtable__ const ILNode_Char_vt__ = {
	&ILNode_Integer_vt__,
	ILNode_Char_kind,
	"ILNode_Char",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Char_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Char_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Char_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_Int32_ILNode_GetType__(ILNode_Int32 *node, ILGenInfo * info)
#line 148 "cg_const.tc"
{ return ILMachineType_Int32; }
#line 669 "cg_const.c"

ILMachineType ILNode_Int32_ILNode_GenValue__(ILNode_Int32 *node, ILGenInfo * info)
#line 238 "cg_const.tc"
{
	if(node->isneg)
	{
		ILGenInt32(info, (ILInt32)(-((ILInt64)(node->value))));
	}
	else
	{
		ILGenInt32(info, (ILInt32)(node->value));
	}
	ILGenAdjust(info, 1);
	return ILMachineType_Int32;
}
#line 685 "cg_const.c"

int ILNode_Int32_ILNode_EvalConst__(ILNode_Int32 *node, ILGenInfo * info, ILEvalValue * value)
#line 396 "cg_const.tc"
{
	value->valueType = ILMachineType_Int32;
	if(node->isneg)
	{
		value->un.i4Value = (ILInt32)(-((ILInt64)(node->value)));
	}
	else
	{
		value->un.i4Value = (ILInt32)(node->value);
	}
	return 1;
}
#line 701 "cg_const.c"

struct ILNode_Int32_vtable__ const ILNode_Int32_vt__ = {
	&ILNode_Integer_vt__,
	ILNode_Int32_kind,
	"ILNode_Int32",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Int32_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Int32_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Int32_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_UInt32_ILNode_GetType__(ILNode_UInt32 *node, ILGenInfo * info)
#line 149 "cg_const.tc"
{ return ILMachineType_UInt32; }
#line 719 "cg_const.c"

ILMachineType ILNode_UInt32_ILNode_GenValue__(ILNode_UInt32 *node, ILGenInfo * info)
#line 251 "cg_const.tc"
{
	ILGenUInt32(info, (ILUInt32)(node->value));
	ILGenAdjust(info, 1);
	return ILMachineType_UInt32;
}
#line 728 "cg_const.c"

int ILNode_UInt32_ILNode_EvalConst__(ILNode_UInt32 *node, ILGenInfo * info, ILEvalValue * value)
#line 409 "cg_const.tc"
{
	value->valueType = ILMachineType_UInt32;
	value->un.i4Value = (ILInt32)(ILUInt32)(node->value);
	return 1;
}
#line 737 "cg_const.c"

struct ILNode_UInt32_vtable__ const ILNode_UInt32_vt__ = {
	&ILNode_Integer_vt__,
	ILNode_UInt32_kind,
	"ILNode_UInt32",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_UInt32_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_UInt32_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_UInt32_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_Int64_ILNode_GetType__(ILNode_Int64 *node, ILGenInfo * info)
#line 150 "cg_const.tc"
{ return ILMachineType_Int64; }
#line 755 "cg_const.c"

ILMachineType ILNode_Int64_ILNode_GenValue__(ILNode_Int64 *node, ILGenInfo * info)
#line 257 "cg_const.tc"
{
	if(node->isneg)
	{
		ILGenInt64(info, -((ILInt64)(node->value)));
	}
	else
	{
		ILGenInt64(info, (ILInt64)(node->value));
	}
	ILGenAdjust(info, 1);
	return ILMachineType_Int64;
}
#line 771 "cg_const.c"

int ILNode_Int64_ILNode_EvalConst__(ILNode_Int64 *node, ILGenInfo * info, ILEvalValue * value)
#line 415 "cg_const.tc"
{
	value->valueType = ILMachineType_Int64;
	if(node->isneg)
	{
		value->un.i8Value = -((ILInt64)(node->value));
	}
	else
	{
		value->un.i8Value = (ILInt64)(node->value);
	}
	return 1;
}
#line 787 "cg_const.c"

struct ILNode_Int64_vtable__ const ILNode_Int64_vt__ = {
	&ILNode_Integer_vt__,
	ILNode_Int64_kind,
	"ILNode_Int64",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Int64_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Int64_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Int64_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_UInt64_ILNode_GetType__(ILNode_UInt64 *node, ILGenInfo * info)
#line 151 "cg_const.tc"
{ return ILMachineType_UInt64; }
#line 805 "cg_const.c"

ILMachineType ILNode_UInt64_ILNode_GenValue__(ILNode_UInt64 *node, ILGenInfo * info)
#line 270 "cg_const.tc"
{
	ILGenUInt64(info, node->value);
	ILGenAdjust(info, 1);
	return ILMachineType_UInt64;
}
#line 814 "cg_const.c"

int ILNode_UInt64_ILNode_EvalConst__(ILNode_UInt64 *node, ILGenInfo * info, ILEvalValue * value)
#line 428 "cg_const.tc"
{
	value->valueType = ILMachineType_UInt64;
	value->un.i8Value = node->value;
	return 1;
}
#line 823 "cg_const.c"

struct ILNode_UInt64_vtable__ const ILNode_UInt64_vt__ = {
	&ILNode_Integer_vt__,
	ILNode_UInt64_kind,
	"ILNode_UInt64",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_UInt64_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_UInt64_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_UInt64_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_Int_ILNode_GetType__(ILNode_Int *node, ILGenInfo * info)
#line 153 "cg_const.tc"
{
	if(node->isneg)
	{
		if(node->value <= (((ILUInt64)(ILUInt32)IL_MAX_INT32) + 1))
		{
			return ILMachineType_NativeInt;
		}
		else
		{
			/* The value is too big for systems with 32-bit native
			   integers, so convert into a 64-bit integer instead */
			return ILMachineType_Int64;
		}
	}
	else
	{
		if(node->value <= (ILUInt64)(ILUInt32)IL_MAX_INT32)
		{
			return ILMachineType_NativeInt;
		}
		else
		{
			/* The value is too big for systems with 32-bit native
			   integers, so convert into a 64-bit integer instead */
			return ILMachineType_Int64;
		}
	}
}
#line 868 "cg_const.c"

ILMachineType ILNode_Int_ILNode_GenValue__(ILNode_Int *node, ILGenInfo * info)
#line 276 "cg_const.tc"
{
	if(node->isneg)
	{
		if(node->value <= (((ILUInt64)(ILUInt32)IL_MAX_INT32) + 1))
		{
			ILGenIntNative(info, (ILInt32)(-((ILInt64)(node->value))));
			ILGenAdjust(info, 1);
			return ILMachineType_NativeInt;
		}
		else
		{
			/* The value is too big for systems with 32-bit native
			   integers, so convert into a 64-bit integer instead */
			ILGenInt64(info, -((ILInt64)(node->value)));
			ILGenAdjust(info, 1);
			return ILMachineType_Int64;
		}
	}
	else
	{
		if(node->value <= (ILUInt64)(ILUInt32)IL_MAX_INT32)
		{
			ILGenIntNative(info, (ILInt32)(node->value));
			ILGenAdjust(info, 1);
			return ILMachineType_NativeInt;
		}
		else
		{
			/* The value is too big for systems with 32-bit native
			   integers, so convert into a 64-bit integer instead */
			ILGenInt64(info, (ILInt64)(node->value));
			ILGenAdjust(info, 1);
			return ILMachineType_Int64;
		}
	}
}
#line 908 "cg_const.c"

int ILNode_Int_ILNode_EvalConst__(ILNode_Int *node, ILGenInfo * info, ILEvalValue * value)
#line 434 "cg_const.tc"
{
	if(node->isneg)
	{
		if(node->value <= (((ILUInt64)(ILUInt32)IL_MAX_INT32) + 1))
		{
			value->valueType = ILMachineType_NativeInt;
			value->un.i4Value = -((ILInt64)(node->value));
		}
		else
		{
			/* The value is too big for systems with 32-bit native
			   integers, so convert into a 64-bit integer instead */
			value->valueType = ILMachineType_Int64;
			value->un.i8Value = -((ILInt64)(node->value));
		}
	}
	else
	{
		if(node->value <= (ILUInt64)(ILUInt32)IL_MAX_INT32)
		{
			value->valueType = ILMachineType_NativeInt;
			value->un.i4Value = (ILInt32)(node->value);
		}
		else
		{
			/* The value is too big for systems with 32-bit native
			   integers, so convert into a 64-bit integer instead */
			value->valueType = ILMachineType_Int64;
			value->un.i8Value = (ILInt64)(node->value);
		}
	}
	return 1;
}
#line 945 "cg_const.c"

struct ILNode_Int_vtable__ const ILNode_Int_vt__ = {
	&ILNode_Integer_vt__,
	ILNode_Int_kind,
	"ILNode_Int",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Int_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Int_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Int_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_UInt_ILNode_GetType__(ILNode_UInt *node, ILGenInfo * info)
#line 182 "cg_const.tc"
{
	if(node->value <= (ILUInt64)IL_MAX_UINT32)
	{
		return ILMachineType_NativeUInt;
	}
	else
	{
		/* The value is too big for systems with 32-bit native
		   integers, so convert into a 64-bit integer instead */
		return ILMachineType_UInt64;
	}
}
#line 974 "cg_const.c"

ILMachineType ILNode_UInt_ILNode_GenValue__(ILNode_UInt *node, ILGenInfo * info)
#line 313 "cg_const.tc"
{
	if(node->value <= (ILUInt64)IL_MAX_UINT32)
	{
		ILGenUIntNative(info, (ILUInt32)(node->value));
		ILGenAdjust(info, 1);
		return ILMachineType_NativeUInt;
	}
	else
	{
		/* The value is too big for systems with 32-bit native
		   integers, so convert into a 64-bit integer instead */
		ILGenUInt64(info, node->value);
		ILGenAdjust(info, 1);
		return ILMachineType_UInt64;
	}
}
#line 994 "cg_const.c"

int ILNode_UInt_ILNode_EvalConst__(ILNode_UInt *node, ILGenInfo * info, ILEvalValue * value)
#line 468 "cg_const.tc"
{
	if(node->value <= (ILUInt64)IL_MAX_UINT32)
	{
		value->valueType = ILMachineType_NativeUInt;
		value->un.i4Value = (ILInt32)(ILUInt32)(node->value);
	}
	else
	{
		/* The value is too big for systems with 32-bit native
		   integers, so convert into a 64-bit integer instead */
		value->valueType = ILMachineType_UInt64;
		value->un.i8Value = (ILInt64)(node->value);
	}
	return 1;
}
#line 1013 "cg_const.c"

struct ILNode_UInt_vtable__ const ILNode_UInt_vt__ = {
	&ILNode_Integer_vt__,
	ILNode_UInt_kind,
	"ILNode_UInt",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_UInt_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_UInt_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Integer_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_UInt_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_Float32_ILNode_GetType__(ILNode_Float32 *node, ILGenInfo * info)
#line 487 "cg_const.tc"
{ return ILMachineType_Float32; }
#line 1031 "cg_const.c"

ILMachineType ILNode_Float32_ILNode_GenValue__(ILNode_Float32 *node, ILGenInfo * info)
#line 495 "cg_const.tc"
{
	ILGenLoadFloat32(info, (ILFloat)(node->value));
	ILGenAdjust(info, 1);
	return ILMachineType_Float32;
}
#line 1040 "cg_const.c"

int ILNode_Float32_ILNode_EvalConst__(ILNode_Float32 *node, ILGenInfo * info, ILEvalValue * value)
#line 535 "cg_const.tc"
{
	value->valueType = ILMachineType_Float32;
	value->un.r4Value = (ILFloat)(node->value);
	return 1;
}
#line 1049 "cg_const.c"

struct ILNode_Float32_vtable__ const ILNode_Float32_vt__ = {
	&ILNode_Real_vt__,
	ILNode_Float32_kind,
	"ILNode_Float32",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Float32_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Float32_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Real_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Real_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Float32_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_Float64_ILNode_GetType__(ILNode_Float64 *node, ILGenInfo * info)
#line 488 "cg_const.tc"
{ return ILMachineType_Float64; }
#line 1067 "cg_const.c"

ILMachineType ILNode_Float64_ILNode_GenValue__(ILNode_Float64 *node, ILGenInfo * info)
#line 501 "cg_const.tc"
{
	ILGenLoadFloat64(info, node->value);
	ILGenAdjust(info, 1);
	return ILMachineType_Float64;
}
#line 1076 "cg_const.c"

int ILNode_Float64_ILNode_EvalConst__(ILNode_Float64 *node, ILGenInfo * info, ILEvalValue * value)
#line 541 "cg_const.tc"
{
	value->valueType = ILMachineType_Float64;
	value->un.r8Value = node->value;
	return 1;
}
#line 1085 "cg_const.c"

struct ILNode_Float64_vtable__ const ILNode_Float64_vt__ = {
	&ILNode_Real_vt__,
	ILNode_Float64_kind,
	"ILNode_Float64",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Float64_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Float64_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Real_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Real_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Float64_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILMachineType ILNode_Float_ILNode_GetType__(ILNode_Float *node, ILGenInfo * info)
#line 489 "cg_const.tc"
{ return ILMachineType_NativeFloat; }
#line 1103 "cg_const.c"

ILMachineType ILNode_Float_ILNode_GenValue__(ILNode_Float *node, ILGenInfo * info)
#line 507 "cg_const.tc"
{
	ILGenLoadFloat64(info, node->value);
	ILGenAdjust(info, 1);
	return ILMachineType_NativeFloat;
}
#line 1112 "cg_const.c"

int ILNode_Float_ILNode_EvalConst__(ILNode_Float *node, ILGenInfo * info, ILEvalValue * value)
#line 547 "cg_const.tc"
{
	value->valueType = ILMachineType_NativeFloat;
	value->un.r8Value = node->value;
	return 1;
}
#line 1121 "cg_const.c"

struct ILNode_Float_vtable__ const ILNode_Float_vt__ = {
	&ILNode_Real_vt__,
	ILNode_Float_kind,
	"ILNode_Float",
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Float_ILNode_GetType__,
	(void (*)(ILNode *this__, ILGenInfo * info))ILNode_Constant_ILNode_GenDiscard__,
	(ILMachineType (*)(ILNode *this__, ILGenInfo * info))ILNode_Float_ILNode_GenValue__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Real_ILNode_GenThen__,
	(void (*)(ILNode *this__, ILGenInfo * info, ILLabel * label))ILNode_Real_ILNode_GenElse__,
	(int (*)(ILNode *this__, ILGenInfo * info, ILEvalValue * value))ILNode_Float_ILNode_EvalConst__,
	(int (*)(ILNode *this__, ILGenInfo * info))ILNode_ILNode_EndsInReturnImpl__,
};

ILNode *ILNode_Null_create(void)
{
	ILNode_Null *node__ = (ILNode_Null *)yynodealloc(sizeof(struct ILNode_Null__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_Null_vt__;
	node__->kind__ = ILNode_Null_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	return (ILNode *)node__;
}

ILNode *ILNode_NullPtr_create(void)
{
	ILNode_NullPtr *node__ = (ILNode_NullPtr *)yynodealloc(sizeof(struct ILNode_NullPtr__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_NullPtr_vt__;
	node__->kind__ = ILNode_NullPtr_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	return (ILNode *)node__;
}

ILNode *ILNode_True_create(void)
{
	ILNode_True *node__ = (ILNode_True *)yynodealloc(sizeof(struct ILNode_True__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_True_vt__;
	node__->kind__ = ILNode_True_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	return (ILNode *)node__;
}

ILNode *ILNode_False_create(void)
{
	ILNode_False *node__ = (ILNode_False *)yynodealloc(sizeof(struct ILNode_False__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_False_vt__;
	node__->kind__ = ILNode_False_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	return (ILNode *)node__;
}

ILNode *ILNode_Decimal_create(ILDecimal value)
{
	ILNode_Decimal *node__ = (ILNode_Decimal *)yynodealloc(sizeof(struct ILNode_Decimal__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_Decimal_vt__;
	node__->kind__ = ILNode_Decimal_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->value = value;
	return (ILNode *)node__;
}

ILNode *ILNode_String_create(char * str, int len)
{
	ILNode_String *node__ = (ILNode_String *)yynodealloc(sizeof(struct ILNode_String__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_String_vt__;
	node__->kind__ = ILNode_String_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->str = str;
	node__->len = len;
	return (ILNode *)node__;
}

ILNode *ILNode_Int8_create(ILUInt64 value, int isneg, int canneg)
{
	ILNode_Int8 *node__ = (ILNode_Int8 *)yynodealloc(sizeof(struct ILNode_Int8__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_Int8_vt__;
	node__->kind__ = ILNode_Int8_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->value = value;
	node__->isneg = isneg;
	node__->canneg = canneg;
	return (ILNode *)node__;
}

ILNode *ILNode_UInt8_create(ILUInt64 value, int isneg, int canneg)
{
	ILNode_UInt8 *node__ = (ILNode_UInt8 *)yynodealloc(sizeof(struct ILNode_UInt8__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_UInt8_vt__;
	node__->kind__ = ILNode_UInt8_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->value = value;
	node__->isneg = isneg;
	node__->canneg = canneg;
	return (ILNode *)node__;
}

ILNode *ILNode_Int16_create(ILUInt64 value, int isneg, int canneg)
{
	ILNode_Int16 *node__ = (ILNode_Int16 *)yynodealloc(sizeof(struct ILNode_Int16__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_Int16_vt__;
	node__->kind__ = ILNode_Int16_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->value = value;
	node__->isneg = isneg;
	node__->canneg = canneg;
	return (ILNode *)node__;
}

ILNode *ILNode_UInt16_create(ILUInt64 value, int isneg, int canneg)
{
	ILNode_UInt16 *node__ = (ILNode_UInt16 *)yynodealloc(sizeof(struct ILNode_UInt16__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_UInt16_vt__;
	node__->kind__ = ILNode_UInt16_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->value = value;
	node__->isneg = isneg;
	node__->canneg = canneg;
	return (ILNode *)node__;
}

ILNode *ILNode_Char_create(ILUInt64 value, int isneg, int canneg)
{
	ILNode_Char *node__ = (ILNode_Char *)yynodealloc(sizeof(struct ILNode_Char__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_Char_vt__;
	node__->kind__ = ILNode_Char_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->value = value;
	node__->isneg = isneg;
	node__->canneg = canneg;
	return (ILNode *)node__;
}

ILNode *ILNode_Int32_create(ILUInt64 value, int isneg, int canneg)
{
	ILNode_Int32 *node__ = (ILNode_Int32 *)yynodealloc(sizeof(struct ILNode_Int32__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_Int32_vt__;
	node__->kind__ = ILNode_Int32_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->value = value;
	node__->isneg = isneg;
	node__->canneg = canneg;
	return (ILNode *)node__;
}

ILNode *ILNode_UInt32_create(ILUInt64 value, int isneg, int canneg)
{
	ILNode_UInt32 *node__ = (ILNode_UInt32 *)yynodealloc(sizeof(struct ILNode_UInt32__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_UInt32_vt__;
	node__->kind__ = ILNode_UInt32_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->value = value;
	node__->isneg = isneg;
	node__->canneg = canneg;
	return (ILNode *)node__;
}

ILNode *ILNode_Int64_create(ILUInt64 value, int isneg, int canneg)
{
	ILNode_Int64 *node__ = (ILNode_Int64 *)yynodealloc(sizeof(struct ILNode_Int64__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_Int64_vt__;
	node__->kind__ = ILNode_Int64_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->value = value;
	node__->isneg = isneg;
	node__->canneg = canneg;
	return (ILNode *)node__;
}

ILNode *ILNode_UInt64_create(ILUInt64 value, int isneg, int canneg)
{
	ILNode_UInt64 *node__ = (ILNode_UInt64 *)yynodealloc(sizeof(struct ILNode_UInt64__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_UInt64_vt__;
	node__->kind__ = ILNode_UInt64_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->value = value;
	node__->isneg = isneg;
	node__->canneg = canneg;
	return (ILNode *)node__;
}

ILNode *ILNode_Int_create(ILUInt64 value, int isneg, int canneg)
{
	ILNode_Int *node__ = (ILNode_Int *)yynodealloc(sizeof(struct ILNode_Int__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_Int_vt__;
	node__->kind__ = ILNode_Int_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->value = value;
	node__->isneg = isneg;
	node__->canneg = canneg;
	return (ILNode *)node__;
}

ILNode *ILNode_UInt_create(ILUInt64 value, int isneg, int canneg)
{
	ILNode_UInt *node__ = (ILNode_UInt *)yynodealloc(sizeof(struct ILNode_UInt__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_UInt_vt__;
	node__->kind__ = ILNode_UInt_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->value = value;
	node__->isneg = isneg;
	node__->canneg = canneg;
	return (ILNode *)node__;
}

ILNode *ILNode_Float32_create(ILDouble value)
{
	ILNode_Float32 *node__ = (ILNode_Float32 *)yynodealloc(sizeof(struct ILNode_Float32__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_Float32_vt__;
	node__->kind__ = ILNode_Float32_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->value = value;
	return (ILNode *)node__;
}

ILNode *ILNode_Float64_create(ILDouble value)
{
	ILNode_Float64 *node__ = (ILNode_Float64 *)yynodealloc(sizeof(struct ILNode_Float64__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_Float64_vt__;
	node__->kind__ = ILNode_Float64_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->value = value;
	return (ILNode *)node__;
}

ILNode *ILNode_Float_create(ILDouble value)
{
	ILNode_Float *node__ = (ILNode_Float *)yynodealloc(sizeof(struct ILNode_Float__));
	if(node__ == 0) return 0;
	node__->vtable__ = &ILNode_Float_vt__;
	node__->kind__ = ILNode_Float_kind;
	node__->filename__ = yycurrfilename();
	node__->linenum__ = yycurrlinenum();
	node__->value = value;
	return (ILNode *)node__;
}

